"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.colorSchemes = exports.default = void 0;
var _default = {
  colors: {
    text: {
      base: '#F9FAFB',
      dark: '#F4F6F8',
      mute: '#aaa',
      light: '#fff'
    },
    dark: {
      base: '#1e262c',
      light: '#454F5B',
      lighter: '#637381'
    },
    primary: {
      base: '#181830',
      light: '#263138',
      lighter: '#34444c',
      dark: '#101021',
      darker: '#090912',
      text: '#F9FAFB'
    },
    secondary: {
      base: '#00707c',
      light: '#007E8A',
      lighter: '#008D99',
      dark: '#00616D',
      darker: '#005662',
      text: '#F9FAFB'
    }
  },
  textFontSize: '14px',
  borderColor: '#70777f',
  borderDarkColor: '#161e23',
  textColor: '#e7f1f4',
  textColorHover: '#fff',
  textMuted: '#70777f',
  fieldWidth: '120px'
};
var _default2 = _default;
exports.default = _default2;
var colorSchemes = {
  solarized: {
    mainBackground: '#f5f5f5',
    navBackground: '#181830',
    buttonBackground: '#00707C',
    hoverButtonBackground: '#096868',
    inputBackground: '#fff',
    inputOutlineColor: '#4d90fe',
    activeTabBackground: '#40545b',
    activeSidebarItemBackground: '#fff',
    tagsBackground: '#28a745',
    tagsColor: '#fff',
    text: '#5d636b',
    title: '#1e262c',
    inputTextColor: '#555555',
    tabTextColor: '#c0c1c1',
    activeTabTextColor: '#fff',
    buttonTextColor: '#fff',
    border: '#d8d8d8',
    overlay: '#787878'
  },
  light: {
    mainBackground: '#f5f5f5',
    navBackground: '#e2e2e2',
    buttonBackground: '#86bc31',
    hoverButtonBackground: '#A4E63C',
    inputBackground: '#fff',
    inputOutlineColor: '#86bc31',
    activeTabBackground: '#f5f5f5',
    activeSidebarItemBackground: '#e2e2e2',
    tagsBackground: '#86bc31',
    tagsColor: '#fff',
    text: '#1a1a1a',
    title: '#1a1a1a',
    inputTextColor: '#999999',
    tabTextColor: '#1a1a1a',
    activeTabTextColor: '#1a1a1a',
    buttonTextColor: '#fff',
    border: '#606060',
    overlay: '#787878'
  },
  dark: {
    mainBackground: '#606060',
    navBackground: '#424242',
    buttonBackground: '#86bc31',
    hoverButtonBackground: '#A4E63C',
    inputBackground: '#fff',
    inputOutlineColor: '#86bc31',
    activeTabBackground: '#606060',
    activeSidebarItemBackground: '#424242',
    tagsBackground: '#86bc31',
    tagsColor: '#fff',
    text: '#e6e6e6',
    title: '#e6e6e6',
    inputTextColor: '#999999',
    tabTextColor: '#fff',
    activeTabTextColor: '#fff',
    buttonTextColor: '#fff',
    border: '#e6e6e6',
    overlay: '#fff'
  },
  purple: {
    mainBackground: '#6767a0',
    navBackground: '#181743',
    buttonBackground: '#37377a',
    hoverButtonBackground: '#4D4DAA',
    inputBackground: '#fff',
    inputOutlineColor: '#37377a',
    activeTabBackground: '#6767a0',
    activeSidebarItemBackground: '#181743',
    tagsBackground: '#37377a',
    tagsColor: '#fff',
    text: '#fff',
    title: '#fff',
    inputTextColor: '#999999',
    tabTextColor: '#fff',
    activeTabTextColor: '#fff',
    buttonTextColor: '#fff',
    border: '#ccc',
    overlay: '#787878'
  },
  lilac: {
    mainBackground: '#f7f7ff',
    navBackground: '#402f80',
    buttonBackground: '#402f80',
    hoverButtonBackground: '#5B43B6',
    inputBackground: '#fff',
    inputOutlineColor: '#402f80',
    activeTabBackground: '#6767a0',
    activeSidebarItemBackground: '#fff',
    tagsBackground: '#402f80',
    tagsColor: '#fff',
    text: '#606060',
    title: '#606060',
    inputTextColor: '#999999',
    tabTextColor: '#fff',
    activeTabTextColor: '#fff',
    buttonTextColor: '#fff',
    border: '#606060',
    overlay: '#787878'
  }
};
exports.colorSchemes = colorSchemes;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(colorSchemes, "colorSchemes", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\assets\\styles\\colorScheme.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\assets\\styles\\colorScheme.js");
}();

;