"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styles = require("../assets/styles");

var _UserUploaderTab = _interopRequireDefault(require("./UploadImagesTab/UserUploaderTab"));

var _styledComponents = require("../styledComponents");

var _Modal = require("./Modal");

var _global = require("../utils/global.utils");

var _config = _interopRequireDefault(require("../config"));

var _reactToastr = require("react-toastr");

var _Nav = _interopRequireDefault(require("./nav/Nav"));

var _reactI18nify = require("react-i18nify");

var _AppState = require("./AppState");

var _icons = require("../utils/icons.utils");

var _api = require("../services/api.service");

var _loadable = require("./loadable");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ToastMessageFactory = /*#__PURE__*/_react.default.createFactory(_reactToastr.ToastMessageAnimated);

var AirstoreUploader = /*#__PURE__*/function (_Component) {
  _inherits(AirstoreUploader, _Component);

  var _super = _createSuper(AirstoreUploader);

  function AirstoreUploader() {
    var _this;

    _classCallCheck(this, AirstoreUploader);

    _this = _super.call(this);

    _defineProperty(_assertThisInitialized(_this), "setPostUpload", function (value) {
      var tabId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      var prevTab = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
      var nextStateProps = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
      var activeTabId = tabId || _this.props.appState.prevTab || 'MY_GALLERY';

      _this.props.setAppState(function () {
        return _objectSpread(_objectSpread({
          activeTabId: activeTabId,
          prevTab: prevTab,
          postUpload: value
        }, nextStateProps), {}, {
          modifyURL: !!nextStateProps.modifyURL
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveUploadedFiles", function () {
      var files = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      _this.props.setAppState(function () {
        return {
          files: files
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "openModal", function (initialTab) {
      var uploaderOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _this$props = _this.props,
          config = _this$props.config,
          appState = _this$props.appState,
          _this$props$options = _this$props.options,
          options = _this$props$options === void 0 ? {} : _this$props$options;
      var activeModules = appState.activeModules;
      var closeOnEdit = options.closeOnEdit || uploaderOptions.closeOnEdit || config.closeOnEdit;
      var closeOnSave = options.closeOnSave || uploaderOptions.closeOnSave || config.closeOnSave;
      var file = uploaderOptions.file;

      var nextOptions = _objectSpread(_objectSpread(_objectSpread({}, options), uploaderOptions), {}, {
        closeOnEdit: (0, _utils.isDefined)(closeOnEdit) ? closeOnEdit : false,
        closeOnSave: (0, _utils.isDefined)(closeOnSave) ? closeOnSave : true
      });

      initialTab = initialTab || _this.props.initialTab || config.initialTab || config.INITIAL_TAB || _config.default.initialTab;
      file = file || _this.props.file;
      var isPostUploadTabs = initialTab === 'TAGGING' || initialTab === 'IMAGE_EDITOR';
      file = isPostUploadTabs && file ? file : null;

      if (isPostUploadTabs && !file) {
        if (activeModules.includes('UPLOAD')) {
          initialTab = 'UPLOAD';
        } else {
          _this.showAlert('Error', 'Cannot open Filerobot Uploader. You did not pass any file to process.');

          return;
        }
      }

      _this.props.setAppState(function (prevState) {
        return _objectSpread(_objectSpread({}, file ? {
          files: [file],
          postUpload: true
        } : {
          postUpload: false
        }), {}, {
          activeTabId: initialTab || _this.props.initialTab,
          isVisible: true,
          prevTab: file ? '' : prevState.prevTab,
          options: nextOptions
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeModal", function (props) {
      var onClose = _this.props.onClose;
      if (onClose) onClose(props);

      _this.props.setAppState(_AppState.getInitialState);
    });

    _defineProperty(_assertThisInitialized(_this), "showAlert", function (title, msg) {
      var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'success';
      var timeOut = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 4000;

      _this.container[type](msg, title, {
        timeOut: timeOut,
        extendedTimeOut: 2000,
        showAnimation: "animated fadeIn",
        hideAnimation: "animated fadeOut"
      });
    });

    _defineProperty(_assertThisInitialized(_this), "activateTab", function (event, tabId) {
      event.preventDefault();

      _this.props.setAppState(function () {
        return {
          prevTab: _this.props.appState.activeTabId,
          activeTabId: tabId
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getPostUploadTabs", function () {
      var _this$props$appState$ = _this.props.appState.files,
          files = _this$props$appState$ === void 0 ? [] : _this$props$appState$;
      var fileType = files[0] && files[0].type;
      var isImageType = (0, _icons.isImage)(fileType);
      if (!isImageType) return postUploadTabs.filter(function (tab) {
        return tab.id !== 'IMAGE_EDITOR';
      });else return postUploadTabs;
    });

    window.AirstoreUploader = window.AirstoreUploader || {};
    window.FilerobotUploader = window.FilerobotUploader || {};
    window.AirstoreUploader.open = _this.openModal;
    window.AirstoreUploader.close = _this.closeModal;
    window.FilerobotUploader.open = window.AirstoreUploader.open;
    window.FilerobotUploader.close = window.AirstoreUploader.close;
    return _this;
  }

  _createClass(AirstoreUploader, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props2 = this.props,
          config = _this$props2.config,
          initialTab = _this$props2.initialTab;
      initialTab = initialTab || config.initialTab || config.INITIAL_TAB || _config.default.initialTab;

      if (this.props.opened) {
        this.init(function () {
          _this2.openModal(initialTab);
        });
      } else {
        this.init();
      }

      window.onresize = function () {
        var isTooSmall = window.innerWidth < 685;

        if (isTooSmall !== _this2.props.appState.isTooSmall) {
          _this2.props.setAppState(function () {
            return {
              isTooSmall: isTooSmall
            };
          });
        }
      };
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.opened !== prevProps.opened) {
        if (this.props.opened) {
          this.init(this.openModal);
        }
      }
    }
  }, {
    key: "init",
    value: function init() {
      var _this3 = this;

      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
      var _this$props3 = this.props,
          config = _this$props3.config,
          onUpload = _this$props3.onUpload;
      var language = config.language || config.LANGUAGE || _config.default.language; // support old config

      var activeModules = config.modules || config.MODULES || _config.default.modules || ["UPLOAD"];
      activeModules = activeModules.join('|').replace('UPLOADED_IMAGES', 'MY_GALLERY').split('|'); // end

      _reactI18nify.I18n.setLocale(language);

      config.modules = activeModules;
      var nextConfig = (0, _global.prepareConfig)(config, onUpload);
      (0, _api.getTokenSettings)(nextConfig).then(function (settings) {
        _this3.props.setAppState(function () {
          return _objectSpread({}, settings);
        });
      }).catch(function (error) {
        var response = error && error.response && error.response.data || {};

        _this3.showAlert(response.msg, response.hint, 'error', 10000);
      });
      this.props.setAppState(function () {
        return {
          config: nextConfig,
          activeModules: activeModules
        };
      }, callback);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var Toaster = function Toaster() {
        return /*#__PURE__*/_react.default.createElement(_reactToastr.ToastContainer, {
          ref: function ref(node) {
            return _this4.container = node;
          },
          toastMessageFactory: ToastMessageFactory,
          className: "toast-top-right"
        });
      };

      if (!this.props.appState.isVisible) return /*#__PURE__*/_react.default.createElement(Toaster, null);
      var _this$props$appState = this.props.appState,
          activeTabId = _this$props$appState.activeTabId,
          activeModules = _this$props$appState.activeModules,
          postUpload = _this$props$appState.postUpload,
          files = _this$props$appState.files,
          path = _this$props$appState.path,
          options = _this$props$appState.options,
          hasChanged = _this$props$appState.hasChanged;
      var config = this.props.config;
      var isMobile = this.props.appState.config.mobile;
      var contentProps = {
        files: files,
        path: path,
        options: options,
        appState: this.props.appState,
        setAppState: this.props.setAppState,
        showAlert: this.showAlert,
        themeColors: config.themeColors,
        setPostUpload: this.setPostUpload,
        saveUploadedFiles: this.saveUploadedFiles,
        closeModal: this.closeModal,
        isMobile: isMobile
      };
      var filteredPostUploadTabs = (postUpload && !isMobile ? this.getPostUploadTabs() : []).filter(function (tab) {
        return tab.id && activeModules.includes(tab.id);
      });
      var filteredTabs = tabs.filter(function (tab) {
        return tab.id && activeModules.includes(tab.id);
      });
      var activeTab = (postUpload ? filteredPostUploadTabs : filteredTabs).find(function (tab) {
        return tab.id === activeTabId;
      });
      var isHideHeader = activeTab && activeTab.id === 'IMAGE_EDITOR';

      if (isMobile) {
        filteredTabs = [tabs.find(function (tab) {
          return tab.id === 'UPLOAD';
        })];
      }

      if (!activeTab) {
        activeTab = (postUpload ? filteredPostUploadTabs : filteredTabs)[0];
      }

      return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
        isTooSmall: isMobile,
        noBorder: true,
        fullScreen: 'md',
        onClose: function onClose() {
          _this4.closeModal({
            hasChanged: hasChanged
          });
        },
        style: {
          borderRadius: 5
        },
        isHideCloseBtn: isHideHeader
      }, /*#__PURE__*/_react.default.createElement("div", {
        id: "filerobot-uploader",
        className: "airstore-root-box",
        style: {
          width: '100%',
          height: '100%'
        }
      }, /*#__PURE__*/_react.default.createElement(_styledComponents.Dialog, {
        role: "dialog",
        className: "ae-dialog"
      }, !isHideHeader && /*#__PURE__*/_react.default.createElement("div", {
        style: _styles.CSS.tabs.header,
        className: "ae-tabs-header"
      }, /*#__PURE__*/_react.default.createElement(_Nav.default, {
        tabs: postUpload ? filteredPostUploadTabs : filteredTabs,
        activeTabId: activeTabId,
        activateTab: this.activateTab
      })), /*#__PURE__*/_react.default.createElement("div", {
        style: _objectSpread(_objectSpread({}, _styles.CSS.tabs.content), activeTabId === 'ICONS' && {
          overflow: 'hidden'
        })
      }, activeTab && /*#__PURE__*/_react.default.createElement("div", {
        style: {
          width: '100%',
          minWidth: isMobile ? 'auto' : 540,
          overflow: 'auto'
        }
      }, activeTab.getContent.call(this, contentProps)))))), /*#__PURE__*/_react.default.createElement(Toaster, null));
    }
  }]);

  return AirstoreUploader;
}(_react.Component);

var tabs = [{
  id: 'UPLOAD',
  fullName: 'Upload',
  shortName: 'upload.tab_title',
  iconClass: 'sfi-airstore-upload',
  getContent: function getContent(props) {
    return /*#__PURE__*/_react.default.createElement(_UserUploaderTab.default, props);
  }
}, {
  id: 'MY_GALLERY',
  fullName: 'My Gallery',
  shortName: 'file_manager.tab_title',
  iconClass: 'sfi-airstore-uploaded-images',
  getContent: function getContent(props) {
    return /*#__PURE__*/_react.default.createElement(_loadable.UploadedImagesTab, props);
  }
}, {
  id: 'ICONS_GALLERY',
  fullName: 'Icons Gallery',
  shortName: 'icons.tab_title',
  iconClass: 'sfi-airstore-gallery',
  getContent: function getContent(props) {
    return /*#__PURE__*/_react.default.createElement(_loadable.IconTab, props);
  }
}, {
  id: 'IMAGES_GALLERY',
  fullName: 'Images Gallery',
  shortName: 'images.tab_title',
  iconClass: 'sfi-airstore-image-gallery',
  getContent: function getContent(props) {
    return /*#__PURE__*/_react.default.createElement(_loadable.BackgroundTab, props);
  }
}];
var postUploadTabs = [{
  id: 'TAGGING',
  fullName: 'TAGGING',
  shortName: 'tagging.tab_title',
  iconClass: 'sfi-airstore-tags',
  getContent: function getContent(props) {
    return /*#__PURE__*/_react.default.createElement(_loadable.TaggingTab, props);
  }
}, {
  id: 'IMAGE_EDITOR',
  fullName: 'IMAGE EDITOR',
  shortName: 'upload.image_editor',
  iconClass: 'sfi-airstore-image-editor',
  getContent: function getContent(props) {
    return /*#__PURE__*/_react.default.createElement(_loadable.ImageEditor, props);
  }
}];
var _default = AirstoreUploader;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(ToastMessageFactory, "ToastMessageFactory", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\AirstoreUploader.js");

  __REACT_HOT_LOADER__.register(AirstoreUploader, "AirstoreUploader", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\AirstoreUploader.js");

  __REACT_HOT_LOADER__.register(tabs, "tabs", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\AirstoreUploader.js");

  __REACT_HOT_LOADER__.register(postUploadTabs, "postUploadTabs", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\AirstoreUploader.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\AirstoreUploader.js");
}();

;