"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _hoc = require("../hoc");

var _styledComponents = require("../../styledComponents");

var _config = require("../../config");

var _helper = require("../../services/helper.service");

var _Spinner = require("../Spinner");

var _reactColor = require("react-color");

var _reactI18nify = require("react-i18nify");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var IconMonoColorSettings = /*#__PURE__*/function (_Component) {
  _inherits(IconMonoColorSettings, _Component);

  var _super = _createSuper(IconMonoColorSettings);

  function IconMonoColorSettings() {
    var _this;

    _classCallCheck(this, IconMonoColorSettings);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      activeColor: '#000000',
      isLoading: true,
      displayColorPicker: false
    });

    _defineProperty(_assertThisInitialized(_this), "setColor", function (color) {
      _this.setState({
        activeColor: color,
        isLoading: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onApply", function () {
      var upload = _this.props.upload;
      var width = 300;
      upload({
        src: _this.getIconUrl(width)
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getIconUrl", function (width) {
      var activeColor = _this.state.activeColor;
      var activeIconSrc = _this.props.activeIconSrc;
      var colorQuery = "tpng.transparentwhite.level".concat(activeColor.replace('#', ''));
      return "https://demoaws.cloudimg.io/width/".concat(width, "/").concat(colorQuery, "/").concat(activeIconSrc, "&v=").concat((0, _helper.guid)());
    });

    _defineProperty(_assertThisInitialized(_this), "onLoad", function () {
      _this.setState({
        isLoading: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClick", function () {
      _this.setState({
        displayColorPicker: !_this.state.displayColorPicker
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (color) {
      _this.setState({
        activeColor: color.hex,
        isLoading: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onOutsideClick", function () {
      _this.setState({
        displayColorPicker: false
      });

      _this.props.onClose();
    });

    return _this;
  }

  _createClass(IconMonoColorSettings, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        if (_this2._buttonSearch && _this2._buttonSearch.focus) _this2._buttonSearch.focus();
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextState.activeColor !== this.state.activeColor || nextState.isLoading !== this.state.isLoading || nextState.displayColorPicker !== this.state.displayColorPicker;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var themeColors = this.props.themeColors;
      var _this$state = this.state,
          isLoading = _this$state.isLoading,
          displayColorPicker = _this$state.displayColorPicker,
          activeColor = _this$state.activeColor;
      var popover = {
        position: 'absolute',
        zIndex: '4',
        top: 0,
        right: -230
      };
      return /*#__PURE__*/_react.default.createElement(_hoc.Aux, null, /*#__PURE__*/_react.default.createElement(_styledComponents.Opacity, {
        isShow: true,
        onClick: function onClick() {
          _this3.onOutsideClick();
        }
      }), /*#__PURE__*/_react.default.createElement(_styledComponents.MonoIconSettings, {
        isShow: true,
        displayColorPicker: displayColorPicker
      }, /*#__PURE__*/_react.default.createElement(_styledComponents.SettingsIconWrapper, null, /*#__PURE__*/_react.default.createElement(_styledComponents.SettingsIcon, {
        src: this.getIconUrl(140),
        onLoad: this.onLoad
      }), /*#__PURE__*/_react.default.createElement(_Spinner.Spinner, {
        overlay: true,
        show: isLoading,
        style: {
          fontSize: 10
        }
      })), /*#__PURE__*/_react.default.createElement(_styledComponents.MonoActionBlock, null, /*#__PURE__*/_react.default.createElement(_styledComponents.Label, null, _reactI18nify.I18n.t('icons.customize_your_icon')), /*#__PURE__*/_react.default.createElement(_styledComponents.ColorsWrapper, null, _config.COLORS.map(function (color, index) {
        return /*#__PURE__*/_react.default.createElement(_styledComponents.ColorIcon, {
          onClick: function onClick() {
            _this3.setColor(color);
          },
          onKeyDown: function onKeyDown(event) {
            event.keyCode === 13 && _this3.setColor(color);
          },
          bgColor: color,
          key: "color-".concat(index),
          tabIndex: 10000,
          role: "button"
        });
      }), /*#__PURE__*/_react.default.createElement(_styledComponents.ColorIcon, {
        onClick: this.handleClick,
        onKeyDown: function onKeyDown(event) {
          event.keyCode === 13 && _this3.handleClick();
        },
        bgColor: "transparent",
        bgImage: '//api.filerobot.com/example/v3/get/a842b7b1-ae10-5e27-8838-fbc7796305fb',
        tabIndex: 10000,
        role: "button"
      })), themeColors && /*#__PURE__*/_react.default.createElement(_styledComponents.ThemeColors, null, /*#__PURE__*/_react.default.createElement(_styledComponents.Label, {
        mr: '5px',
        p: '0px'
      }, _reactI18nify.I18n.t('icons.theme_colors'), ":"), /*#__PURE__*/_react.default.createElement(_styledComponents.ColorIcon, {
        onClick: function onClick() {
          _this3.setColor(themeColors.primary);
        },
        bgColor: themeColors.primary
      }), /*#__PURE__*/_react.default.createElement(_styledComponents.ColorIcon, {
        onClick: function onClick() {
          _this3.setColor(themeColors.secondary);
        },
        bgColor: themeColors.secondary
      })), /*#__PURE__*/_react.default.createElement(_styledComponents.ButtonSearch, {
        ref: function ref(node) {
          return _this3._buttonSearch = node;
        },
        fullBr: '4px',
        onClick: this.onApply,
        tabIndex: 10001
      }, _reactI18nify.I18n.t('upload.apply'))), displayColorPicker ? /*#__PURE__*/_react.default.createElement("div", {
        style: popover
      }, /*#__PURE__*/_react.default.createElement(_reactColor.SketchPicker, {
        color: activeColor,
        onChange: this.handleChange
      })) : null));
    }
  }]);

  return IconMonoColorSettings;
}(_react.Component);

var _default = IconMonoColorSettings;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(IconMonoColorSettings, "IconMonoColorSettings", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\IconsTab\\IconMonoColorSettings.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\IconsTab\\IconMonoColorSettings.js");
}();

;