"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../styledComponents/index");

var _reactI18nify = require("react-i18nify");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var tags = [{
  tag: 'sf-social',
  label: 'Social',
  count: '23'
}, {
  tag: 'arrows',
  label: 'Arrows',
  count: '5414'
}, {
  tag: 'audio',
  label: 'Audio & Video',
  count: '2716'
}, {
  tag: 'date',
  label: 'Date & Time',
  count: '1523'
}, {
  tag: 'currency',
  label: 'Currency',
  count: '3531'
}, {
  tag: 'business',
  label: 'Business',
  count: '8882'
}];

var IconSidebar = /*#__PURE__*/function (_Component) {
  _inherits(IconSidebar, _Component);

  var _super = _createSuper(IconSidebar);

  function IconSidebar() {
    var _this;

    _classCallCheck(this, IconSidebar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "renderTag", function (_ref) {
      var tag = _ref.tag,
          label = _ref.label,
          count = _ref.count;
      var _this$props = _this.props,
          activePresetTag = _this$props.activePresetTag,
          onActivatePresetTag = _this$props.onActivatePresetTag;
      return /*#__PURE__*/_react.default.createElement(_index.ColorItem, {
        key: "category-".concat(tag),
        active: tag === activePresetTag,
        onClick: function onClick() {
          onActivatePresetTag(tag);
        },
        onKeyDown: function onKeyDown(event) {
          event.keyCode === 13 && onActivatePresetTag(tag);
        },
        tabIndex: 0,
        role: "button"
      }, /*#__PURE__*/_react.default.createElement(_index.ColorItemName, null, label || tag.replace(/_/g, ' ').trim()), /*#__PURE__*/_react.default.createElement(_index.CountTag, null, "(", count, ")"));
    });

    return _this;
  }

  _createClass(IconSidebar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          toggleColorType = _this$props2.toggleColorType,
          activeColorType = _this$props2.activeColorType;
      return /*#__PURE__*/_react.default.createElement(_index.SidebarWrap, null, /*#__PURE__*/_react.default.createElement(_index.SideBar, {
        id: "airstore-uploader-tags-box"
      }, /*#__PURE__*/_react.default.createElement(_index.Label, {
        fs: '16px'
      }, _reactI18nify.I18n.t('icons.color_filter')), /*#__PURE__*/_react.default.createElement(_index.ColorWrapper, null, /*#__PURE__*/_react.default.createElement(_index.ColorItem, {
        key: "all-color-wrapper",
        active: activeColorType === 'all',
        onClick: function onClick() {
          toggleColorType('all');
        },
        onKeyDown: function onKeyDown(event) {
          event.keyCode === 13 && toggleColorType('all');
        },
        tabIndex: 0,
        role: "button"
      }, /*#__PURE__*/_react.default.createElement(_index.ColorItemName, null, _reactI18nify.I18n.t('icons.all'))), /*#__PURE__*/_react.default.createElement(_index.ColorItem, {
        active: activeColorType === 'multi',
        key: "multi-color-wrapper",
        onClick: function onClick() {
          toggleColorType('multi');
        },
        onKeyDown: function onKeyDown(event) {
          event.keyCode === 13 && toggleColorType('multi');
        },
        tabIndex: 0,
        role: "button"
      }, /*#__PURE__*/_react.default.createElement(_index.ColorItemName, null, _reactI18nify.I18n.t('icons.multi_color'))), /*#__PURE__*/_react.default.createElement(_index.ColorItem, {
        active: activeColorType === 'mono',
        key: "mono-color-wrapper",
        onClick: function onClick() {
          toggleColorType('mono');
        },
        onKeyDown: function onKeyDown(event) {
          event.keyCode === 13 && toggleColorType('mono');
        },
        tabIndex: 0,
        role: "button"
      }, /*#__PURE__*/_react.default.createElement(_index.ColorItemName, null, _reactI18nify.I18n.t('icons.mono_color')))), /*#__PURE__*/_react.default.createElement(_index.Label, {
        fs: '16px',
        color: 'black'
      }, _reactI18nify.I18n.t('upload.categories')), tags && tags.sort(function (a, b) {
        return a.tag > b.tag ? 1 : -1;
      }).map(function (tag) {
        return _this2.renderTag(tag);
      })));
    }
  }]);

  return IconSidebar;
}(_react.Component);

var _default = IconSidebar;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(tags, "tags", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\IconsTab\\IconSidebar.js");

  __REACT_HOT_LOADER__.register(IconSidebar, "IconSidebar", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\IconsTab\\IconSidebar.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\IconsTab\\IconSidebar.js");
}();

;