"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _utils = require("../../utils");

var _styledComponents = require("../../styledComponents");

var _reactI18nify = require("react-i18nify");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var SearchBar = /*#__PURE__*/function (_Component) {
  _inherits(SearchBar, _Component);

  var _super = _createSuper(SearchBar);

  function SearchBar() {
    _classCallCheck(this, SearchBar);

    return _super.apply(this, arguments);
  }

  _createClass(SearchBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this = this;

      setTimeout(function () {
        if (_this.searchField && _this.searchField.focus) _this.searchField.focus();
      });
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (!nextProps.isLoading && nextProps.isLoading !== this.props.isLoading && this.searchField && this.searchField.focus) this.searchField.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          items = _this$props.items,
          isSearching = _this$props.isSearching,
          searchPhrase = _this$props.searchPhrase,
          onSearch = _this$props.onSearch,
          onChangeSearchPhrase = _this$props.onChangeSearchPhrase,
          title = _this$props.title,
          _this$props$count = _this$props.count,
          count = _this$props$count === void 0 ? 0 : _this$props$count,
          _this$props$presetIma = _this$props.presetImagesCount,
          presetImagesCount = _this$props$presetIma === void 0 ? 0 : _this$props$presetIma;
      var isEmptyIcons = !items || !items.length;
      return /*#__PURE__*/_react.default.createElement(_styledComponents.SearchWrapper, {
        empty: isEmptyIcons && !isSearching
      }, /*#__PURE__*/_react.default.createElement(_styledComponents.SearchTitle, {
        show: isEmptyIcons && !isSearching
      }, title), /*#__PURE__*/_react.default.createElement(_styledComponents.SearchGroup, null, /*#__PURE__*/_react.default.createElement(_styledComponents.InputSearch, {
        type: "search",
        ref: function ref(node) {
          return _this2.searchField = node;
        },
        autoFocus: true,
        value: searchPhrase,
        onChange: onChangeSearchPhrase,
        onKeyDown: function onKeyDown(ev) {
          (0, _utils.isEnterClick)(ev) && onSearch();
        }
      }), /*#__PURE__*/_react.default.createElement(_styledComponents.ButtonSearch, {
        className: "ae-btn",
        onClick: function onClick() {
          onSearch();
        }
      }, _reactI18nify.I18n.t('upload.search'))), /*#__PURE__*/_react.default.createElement(_styledComponents.AmountIcons, {
        empty: isEmptyIcons
      }, _reactI18nify.I18n.t('upload.found'), ": ", presetImagesCount || count ? presetImagesCount || count : ''));
    }
  }]);

  return SearchBar;
}(_react.Component);

var _default = SearchBar;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(SearchBar, "SearchBar", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\IconsTab\\SearchBar.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\IconsTab\\SearchBar.js");
}();

;