"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactI18nify = require("react-i18nify");

var _Spinner = require("../Spinner");

var _styledComponents = require("../../styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = function _default(props) {
  var activePresetTag = props.activePresetTag,
      activeColorFilters = props.activeColorFilters,
      tags = props.tags,
      backgrounds = props.backgrounds,
      onChangeColorFilter = props.onChangeColorFilter,
      onRemoveColorFilter = props.onRemoveColorFilter,
      addColorFilter = props.addColorFilter,
      onActivatePresetTag = props.onActivatePresetTag;
  return /*#__PURE__*/_react.default.createElement(_styledComponents.SidebarWrap, null, /*#__PURE__*/_react.default.createElement(_styledComponents.SideBar, null, /*#__PURE__*/_react.default.createElement(_styledComponents.Label, {
    fs: '16px',
    color: 'black'
  }, _reactI18nify.I18n.t('images.color_filter')), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      margin: '0 10px'
    }
  }, activeColorFilters.map(function (colorFilter, index) {
    return /*#__PURE__*/_react.default.createElement(_styledComponents.ColorFilterItem, {
      index: index,
      key: "colorFilter-".concat(index),
      color: colorFilter.value,
      onChangeColorFilter: onChangeColorFilter,
      onRemoveColorFilter: onRemoveColorFilter
    });
  })), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      padding: '5px 10px 12px'
    }
  }, /*#__PURE__*/_react.default.createElement(_styledComponents.AddColorBtn, {
    onClick: addColorFilter,
    onKeyDown: function onKeyDown(event) {
      event.keyCode === 13 && addColorFilter();
    },
    tabIndex: 0,
    role: "button"
  }, "+ ", _reactI18nify.I18n.t('images.add_color'))), /*#__PURE__*/_react.default.createElement(_styledComponents.Label, {
    fs: '16px',
    color: 'black'
  }, _reactI18nify.I18n.t('upload.categories')), tags.length && /*#__PURE__*/_react.default.createElement(_styledComponents.ColorItem, {
    key: "category-background",
    active: 'backgrounds' === activePresetTag,
    onClick: function onClick() {
      onActivatePresetTag('backgrounds', 25);
    },
    tabIndex: 0,
    role: "button"
  }, /*#__PURE__*/_react.default.createElement(_styledComponents.ColorItemName, null, _reactI18nify.I18n.t('images.backgrounds'), " "), /*#__PURE__*/_react.default.createElement(_styledComponents.CountTag, null, "(25+)")), tags.slice(0, 20).map(function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        tag = _ref.tag,
        label = _ref.label,
        count = _ref.count;

    return /*#__PURE__*/_react.default.createElement(_styledComponents.ColorItem, {
      key: "category-".concat(tag),
      active: tag === activePresetTag,
      onClick: function onClick() {
        onActivatePresetTag(tag, count);
      },
      onKeyDown: function onKeyDown(event) {
        event.keyCode === 13 && onActivatePresetTag(tag);
      },
      tabIndex: 0,
      role: "button"
    }, /*#__PURE__*/_react.default.createElement(_styledComponents.ColorItemName, {
      title: label || tag.replace(/_/g, ' ').trim()
    }, label || tag.replace(/_/g, ' ').trim()), /*#__PURE__*/_react.default.createElement(_styledComponents.CountTag, null, "(", count, ")"));
  }), !tags.length ? /*#__PURE__*/_react.default.createElement(_Spinner.Spinner, {
    black: true,
    show: true,
    style: {
      fontSize: 8,
      top: 10,
      opacity: 0.4
    }
  }) : null));
};

var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\ImagesTab\\ImagesSidebar.js");
}();

;