"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _TaggingTab = require("./TaggingTab.styled");

var _CloseBtn = require("../CloseBtn");

var _smartcrop = _interopRequireDefault(require("smartcrop"));

var _reactI18nify = require("react-i18nify");

var API = _interopRequireWildcard(require("../../services/api.service"));

var _utils = require("../../utils");

var _md = _interopRequireDefault(require("../../utils/md5"));

var _adjustAPI = require("../../utils/adjustAPI.utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var OPTIONS_1x1 = [{
  height: 125,
  width: 125,
  debug: true,
  minScale: 1
}, {
  height: 125,
  width: 125,
  debug: true,
  minScale: 0.88
}, {
  height: 125,
  width: 125,
  debug: true,
  minScale: 0.77
}, {
  height: 125,
  width: 125,
  debug: true,
  minScale: 0.65
}];
var OPTIONS_5x4 = [{
  height: 125,
  width: 156.25,
  debug: true,
  minScale: 1
}, {
  height: 125,
  width: 156.25,
  debug: true,
  minScale: 0.82
}, {
  height: 125,
  width: 156.25,
  debug: true,
  minScale: 0.65
}];
var OPTIONS_4x3 = [{
  height: 125,
  width: 166.7,
  debug: true,
  minScale: 1
}, {
  height: 125,
  width: 166.7,
  debug: true,
  minScale: 0.82
}, {
  height: 125,
  width: 166.7,
  debug: true,
  minScale: 0.65
}];
var OPTIONS_3x2 = [{
  height: 125,
  width: 187.5,
  debug: true,
  minScale: 1
}, {
  height: 125,
  width: 187.5,
  debug: true,
  minScale: 0.82
}, {
  height: 125,
  width: 187.5,
  debug: true,
  minScale: 0.65
}];
var OPTIONS_16x9 = [{
  height: 125,
  width: 222,
  debug: true,
  minScale: 1
}, {
  height: 125,
  width: 222,
  debug: true,
  minScale: 0.82
}, {
  height: 125,
  width: 222,
  debug: true,
  minScale: 0.65
}];

var CropsBox = /*#__PURE__*/function (_Component) {
  _inherits(CropsBox, _Component);

  var _super = _createSuper(CropsBox);

  function CropsBox() {
    var _this;

    _classCallCheck(this, CropsBox);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "processAutoCrop", function (group, groupName, img) {
      group.forEach(function (options, index) {
        _smartcrop.default.crop(img, options).then(function (result) {
          var crop = result.topCrop;

          var canvas = _this.refs["".concat(groupName).concat(index)];

          var ctx = canvas.getContext('2d');
          _this[groupName] = _this[groupName] || [];
          _this[groupName][index] = crop;
          canvas.width = options.width;
          canvas.height = options.height;
          ctx.drawImage(img, crop.x, crop.y, crop.width, crop.height, 0, 0, canvas.width, canvas.height);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "uploadSuccess", function (src) {
      var img = new Image();
      img.crossOrigin = '';
      img.src = _this.props.src;

      img.onload = function () {
        _this.processAutoCrop(OPTIONS_1x1, 'canvas_1x1_', img);

        _this.processAutoCrop(OPTIONS_5x4, 'canvas_5x4_', img);

        _this.processAutoCrop(OPTIONS_4x3, 'canvas_4x3_', img);

        _this.processAutoCrop(OPTIONS_3x2, 'canvas_3x2_', img);

        _this.processAutoCrop(OPTIONS_16x9, 'canvas_16x9_', img);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "uploadFromWeb", function () {
      var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var config = _this.props.appState.config;
      var files = [url];
      var dataType = 'application/json';

      _this.props.setSpinner(true);

      API.uploadFiles({
        files: files,
        config: config,
        data_type: dataType,
        showAlert: _this.props.showAlert
      }).then(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 3),
            _ref2$ = _ref2[0],
            files = _ref2$ === void 0 ? [] : _ref2$,
            isDuplicate = _ref2[1],
            isReplacingData = _ref2[2];

        if (isReplacingData || isDuplicate) {
          _this.props.showAlert('', _reactI18nify.I18n.t('upload.file_already_exists'), 'info');
        }

        var file = files[0] || {};

        _this.uploadSuccess((0, _utils.encodePermalink)((0, _adjustAPI.getPubliclink)(file)));

        _this.props.saveUploadedFiles(files);

        _this.props.setSpinner(false);

        _this.props.toggleCropMenu();
      }).catch(function (error) {
        _this.props.setSpinner(false);

        _this.props.showAlert('', error.msg, 'error');
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onCanvasClick", function (groupName, index) {
      var url = _this.generateCloudimageURL(_this[groupName][index]);

      _this.uploadFromWeb("".concat(url).concat(_this.props.src));
    });

    _defineProperty(_assertThisInitialized(_this), "generateCloudimageURL", function () {
      var cropParams = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var config = _this.props.appState.config;
      var cloudUrl = config.cloudimageToken + '.cloudimg.io' + '/';
      var width = cropParams.width,
          height = cropParams.height,
          x = cropParams.x,
          y = cropParams.y;
      var cropQ = x + ',' + y + ',' + (x + width) + ',' + (y + height) + '-' + width + 'x' + height;
      return "https://".concat(cloudUrl, "crop_px/").concat(cropQ, "/n/");
    });

    _defineProperty(_assertThisInitialized(_this), "renderCanvas", function (index, groupName) {
      return /*#__PURE__*/_react.default.createElement("canvas", {
        onClick: function onClick() {
          _this.onCanvasClick(groupName, index);
        },
        key: index,
        ref: "".concat(groupName).concat(index)
      });
    });

    return _this;
  }

  _createClass(CropsBox, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.uploadSuccess(this.props.src);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var show = this.props.show;
      return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, show && /*#__PURE__*/_react.default.createElement(_TaggingTab.Overlay, {
        onClick: this.props.toggleCropMenu
      }), /*#__PURE__*/_react.default.createElement(_TaggingTab.CropsBoxWrapper, {
        show: show
      }, /*#__PURE__*/_react.default.createElement(_CloseBtn.CloseBtn, {
        onClick: this.props.toggleCropMenu
      }), /*#__PURE__*/_react.default.createElement(_TaggingTab.GroupLabel, null, "1x1"), /*#__PURE__*/_react.default.createElement(_TaggingTab.Group, null, OPTIONS_1x1.map(function (option, index) {
        return _this2.renderCanvas(index, 'canvas_1x1_');
      })), /*#__PURE__*/_react.default.createElement(_TaggingTab.GroupLabel, null, "5x4"), /*#__PURE__*/_react.default.createElement(_TaggingTab.Group, null, OPTIONS_5x4.map(function (option, index) {
        return _this2.renderCanvas(index, 'canvas_5x4_');
      })), /*#__PURE__*/_react.default.createElement(_TaggingTab.GroupLabel, null, "4x3"), /*#__PURE__*/_react.default.createElement(_TaggingTab.Group, null, OPTIONS_4x3.map(function (option, index) {
        return _this2.renderCanvas(index, 'canvas_4x3_');
      })), /*#__PURE__*/_react.default.createElement(_TaggingTab.GroupLabel, null, "3x2"), /*#__PURE__*/_react.default.createElement(_TaggingTab.Group, null, OPTIONS_3x2.map(function (option, index) {
        return _this2.renderCanvas(index, 'canvas_3x2_');
      })), /*#__PURE__*/_react.default.createElement(_TaggingTab.GroupLabel, null, "16x9"), /*#__PURE__*/_react.default.createElement(_TaggingTab.Group, null, OPTIONS_16x9.map(function (option, index) {
        return _this2.renderCanvas(index, 'canvas_16x9_');
      }))));
    }
  }]);

  return CropsBox;
}(_react.Component);

var _default = CropsBox;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(OPTIONS_1x1, "OPTIONS_1x1", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\CropsBox.js");

  __REACT_HOT_LOADER__.register(OPTIONS_5x4, "OPTIONS_5x4", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\CropsBox.js");

  __REACT_HOT_LOADER__.register(OPTIONS_4x3, "OPTIONS_4x3", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\CropsBox.js");

  __REACT_HOT_LOADER__.register(OPTIONS_3x2, "OPTIONS_3x2", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\CropsBox.js");

  __REACT_HOT_LOADER__.register(OPTIONS_16x9, "OPTIONS_16x9", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\CropsBox.js");

  __REACT_HOT_LOADER__.register(CropsBox, "CropsBox", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\CropsBox.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\CropsBox.js");
}();

;