"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _prettyBytes = _interopRequireDefault(require("pretty-bytes"));

var _reactTagsinput = _interopRequireDefault(require("react-tagsinput"));

var _Spinner = require("../Spinner");

var _TaggingTabStyled = require("./TaggingTab.styled.js");

var _reactTooltip = _interopRequireDefault(require("react-tooltip"));

var _api = require("../../services/api.service");

var _reactI18nify = require("react-i18nify");

var _helper = require("../../utils/helper.utils");

var _icons = require("../../utils/icons.utils");

var _utils = require("../../utils");

var _adjustAPI = require("../../utils/adjustAPI.utils");

var _AutosuggestionInput = _interopRequireDefault(require("./AutosuggestionInput"));

var _confirmPopup = _interopRequireDefault(require("../confirm-popup"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TaggingTab = /*#__PURE__*/function (_Component) {
  _inherits(TaggingTab, _Component);

  var _super = _createSuper(TaggingTab);

  function TaggingTab(_props) {
    var _this;

    _classCallCheck(this, TaggingTab);

    _this = _super.call(this);

    _defineProperty(_assertThisInitialized(_this), "showTags", function (tokenMetadata) {
      var _this$props$appState$ = _this.props.appState.files,
          files = _this$props$appState$ === void 0 ? [] : _this$props$appState$;
      var isEDGYMetadataVersion = tokenMetadata.isEDGYMetadataVersion,
          isTagsField = tokenMetadata.isTagsField,
          firstFieldWithTags = tokenMetadata.firstFieldWithTags;
      var isOneFile = files.length === 1;
      var firstFile = files[0];
      var commonTags = [];
      var personalTags = [];
      var firstFieldTags = [];
      var tags = [];

      if (isEDGYMetadataVersion && isTagsField) {
        files.forEach(function (file) {
          file.properties = file.properties || {};
          firstFieldTags = firstFieldWithTags.regional_variants && !!firstFieldWithTags.regional_variants.length ? file.properties[firstFieldWithTags.key] ? file.properties[firstFieldWithTags.key][firstFieldWithTags.regional_variants[0]] : [] : [];
          commonTags.push.apply(commonTags, _toConsumableArray(firstFieldTags));
          personalTags[file.uuid] = firstFieldTags;
        });
        tags = isOneFile ? firstFieldTags : (0, _helper.nonUniqueArrayOfStrings)(commonTags, files.length);
      } else {
        files.forEach(function (file) {
          file.properties = file.properties || {};
          file.properties.tags = file.properties.tags || [];
          commonTags.push.apply(commonTags, _toConsumableArray(file.properties.tags));
          personalTags[file.uuid] = file.properties.tags;
        });
        tags = isOneFile ? firstFile.properties.tags : (0, _helper.nonUniqueArrayOfStrings)(commonTags, files.length);
      }

      var nextState = _objectSpread(_objectSpread({}, _this.state), {}, {
        tags: tags,
        personalTags: (0, _helper.uniqueArrayOfStringsInObject)(personalTags),
        isLoading: false
      });

      _this.initialData["tags"] = tags;

      _this.setState(nextState);

      _this.props.setAppState({
        isClickedTagsBtn: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getTokenData", function () {
      var appState = _this.props.appState;
      var config = appState.config;
      var baseAPI = config.baseAPI,
          container = config.container,
          platform = config.platform,
          uploadKey = config.uploadKey;
      var tokenMetadata = {};
      var firstFieldWithTags = null;

      _this.setState({
        isLoading: true
      });

      return (0, _api.getTokenData)({
        baseAPI: baseAPI,
        container: container,
        platform: platform,
        uploadKey: uploadKey
      }).then(function (tokenData) {
        var isEDGYMetadataVersion = (0, _helper.checkIsEDGYMetadataVersion)(tokenData.metadata.version);
        var FILES = tokenData.metadata.model && tokenData.metadata.model.find(function (model) {
          return model.applies_to === 'FILES';
        });
        var isTagsField = FILES ? FILES.groups.some(function (group) {
          return group.fields.some(function (field) {
            return field.type === 'tags';
          });
        }) : false;

        if (FILES && isTagsField) {
          FILES.groups.forEach(function (group) {
            var fieldWithTags = group.fields.find(function (field) {
              return field.type === 'tags';
            });
            if (fieldWithTags) firstFieldWithTags = fieldWithTags;
          });
        }

        tokenMetadata = {
          isEDGYMetadataVersion: isEDGYMetadataVersion,
          isTagsField: isTagsField,
          firstFieldWithTags: firstFieldWithTags
        };

        _this.setState({
          tokenMetadata: tokenMetadata
        });

        return Promise.resolve(tokenMetadata);
      }).catch(function (error) {
        var response = error && error.response && error.response.data || {};

        _this.props.showAlert(response.msg, response.hint, 'error', 10000);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleDescriptionChange", function (event) {
      _this.setState({
        description: event.target.value,
        errorMessage: ''
      });

      _this.props.setAppState({
        hasChanged: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleTagsChange", function () {
      var newTags = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var lastTag = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var removedTags = _this.state.removedTags;
      var isNewAdded = newTags.includes(lastTag[0]);

      _this.setState({
        tags: newTags,
        errorMessage: ''
      });

      _this.props.setAppState({
        hasChanged: true
      });

      if (!isNewAdded) {
        var nextRemovedTags = [].concat(_toConsumableArray(removedTags), _toConsumableArray(lastTag));

        _this.setState({
          removedTags: nextRemovedTags
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getCustomFields", function () {
      var customFields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var properties = arguments.length > 1 ? arguments[1] : undefined;
      var customFieldsProps = {};
      customFields.forEach(function (field) {
        customFieldsProps[field.metaKey] = properties[field.metaKey] || '';
      });
      return customFieldsProps;
    });

    _defineProperty(_assertThisInitialized(_this), "saveMetadataAndModify", function () {
      _this.saveMetadata(true, function () {
        if (_this.props.appState.config.imageEditor.active) {
          var _this$props = _this.props,
              path = _this$props.path,
              files = _this$props.files;

          _this.props.saveUploadedFiles(files);

          _this.props.setPostUpload(true, 'IMAGE_EDITOR', 'MY_GALLERY', {
            path: path,
            modifyURL: true
          });
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveMetadata", function (isModifyURL, callback) {
      var _this$state = _this.state,
          description = _this$state.description,
          tags = _this$state.tags,
          personalTags = _this$state.personalTags,
          removedTags = _this$state.removedTags,
          tokenMetadata = _this$state.tokenMetadata;
      var _this$props2 = _this.props,
          appState = _this$props2.appState,
          _this$props2$files = _this$props2.files,
          files = _this$props2$files === void 0 ? [] : _this$props2$files,
          _this$props2$options = _this$props2.options,
          options = _this$props2$options === void 0 ? {} : _this$props2$options;
      var prevTab = appState.prevTab;
      var _appState$config = appState.config,
          uploadHandler = _appState$config.uploadHandler,
          language = _appState$config.language,
          tagging = _appState$config.tagging;
      var _tagging$customFields = tagging.customFields,
          customFields = _tagging$customFields === void 0 ? [] : _tagging$customFields;
      var nextPersonalTags = {};
      var customFieldsProps = {};
      Object.keys(personalTags).forEach(function (key) {
        nextPersonalTags[key] = personalTags[key].filter(function (tag) {
          return !removedTags.find(function (removedTag) {
            return removedTag === tag;
          });
        });
      });

      if (customFields && customFields.length) {
        customFieldsProps = _this.getCustomFields(customFields, _this.state);
      }

      (0, _api.saveMetaData)({
        files: files,
        properties: _objectSpread({
          description: description,
          tags: (0, _helper.uniqueArrayOfStrings)(tags),
          lang: language,
          search: "".concat(description, " ").concat(tags.join(' '))
        }, customFieldsProps),
        config: appState.config,
        personalTags: nextPersonalTags,
        tokenMetadata: tokenMetadata
      }).then(function (images) {
        images.forEach(function (image) {
          if (image.status === 'success') {
            var findIndex = files.findIndex(function (file) {
              return file.uuid === image.file_uuid;
            });
            files[findIndex].properties = image.properties;
          } else {
            _this.setState({
              errorMessage: image.msg || image.message || _reactI18nify.I18n.t('tagging.something_went_wrong_try_again'),
              isLoading: false
            });
          }
        });
        uploadHandler(files, {
          stage: 'tagging'
        });

        _this.setState({
          isLoading: true
        }, function () {
          _this.props.setPostUpload(false, '', 'TAGGING');

          if (options.closeOnSave) {
            if ((options.closeOnEdit || prevTab !== 'MY_GALLERY') && !isModifyURL) {
              _this.props.closeModal();
            }
          }

          if (typeof callback === "function") {
            callback();
          }
        });
      });

      _this.props.setAppState({
        hasChanged: false,
        uploadedImageData: {}
      });

      _this.setState({
        isLoading: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "generateTags", function (isOneFile) {
      if (_this.state.tagsGenerated) return;

      _this.setState({
        isGeneratingTags: true
      });

      var _this$props3 = _this.props,
          appState = _this$props3.appState,
          files = _this$props3.files;
      var _appState$config2 = appState.config,
          tagging = _appState$config2.tagging,
          language = _appState$config2.language,
          container = _appState$config2.container,
          baseAPI = _appState$config2.baseAPI,
          platform = _appState$config2.platform,
          uploadKey = _appState$config2.uploadKey,
          cloudimageToken = _appState$config2.cloudimageToken;
      var firstFile = files[0];
      var filesUuids = files.map(function (file) {
        return file.uuid;
      }); //let filesWithoutTags = [];
      //filesWithoutTags = files.filter(file => !file.properties.tags.length).map(file => file.uuid);

      isOneFile ? (0, _api.generateTags)(firstFile.uuid, tagging, language, container, baseAPI, platform, uploadKey, cloudimageToken).then(function () {
        var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            tags = _ref.tags,
            props = _objectWithoutProperties(_ref, ["tags"]);

        if (tags) {
          if (!tags.length) {
            _this.props.showAlert(_reactI18nify.I18n.t('tagging.asset_could_not_be_automatically_tagged'), '', 'warning');

            _this.setState({
              isLoading: false,
              isGeneratingTags: false
            });

            return;
          }

          var nextTags = [].concat(_toConsumableArray(_this.state.tags), _toConsumableArray(tags.map(function (item) {
            return item && item.tag && item.tag[language];
          })));
          var uniqueTags = (0, _helper.uniqueArrayOfStrings)(nextTags);
          _this.initialData["tags"] = uniqueTags;

          _this.setState({
            tags: uniqueTags,
            isLoading: false,
            isGeneratingTags: false,
            tagsGenerated: true
          });
        } else {
          _this.setState({
            isLoading: false,
            isGeneratingTags: false,
            errorMessage: props.msg || props.message || _reactI18nify.I18n.t('tagging.something_went_wrong_try_again')
          });
        }
      }).catch(function (error) {
        var _error$response = error.response;
        _error$response = _error$response === void 0 ? {} : _error$response;
        var _error$response$data = _error$response.data,
            data = _error$response$data === void 0 ? {} : _error$response$data;

        _this.setState({
          isLoading: false,
          isGeneratingTags: false,
          errorMessage: data.msg || error.message || error.msg || _reactI18nify.I18n.t('tagging.something_went_wrong_try_again')
        });
      }) : (0, _api.generateMultiplyImagesTags)(filesUuids, tagging, language, container, baseAPI, platform, uploadKey, cloudimageToken).then(function (images) {
        var commonTags = [];
        var personalTags = {};
        files.forEach(function (image) {
          personalTags[image.uuid] = image.properties.tags;
        });
        images.forEach(function (image) {
          if (image.tags) {
            if (!image.tags.length) {
              var imageName = image.meta.url.match(/[\w-]+\.(jpg|png|jpeg|svg|gif|WebP)/g)[0] || '';

              _this.props.showAlert("".concat(imageName, " ").concat(_reactI18nify.I18n.t('tagging.could_not_be_automatically_tagged')), '', 'warning');
            } else {
              commonTags.push.apply(commonTags, _toConsumableArray(image.tags.map(function (tag) {
                return tag && tag.tag && tag.tag[language];
              })));
              personalTags[image.meta.uuid] = _toConsumableArray(image.tags.map(function (tag) {
                return tag && tag.tag && tag.tag[language];
              }));
            }
          }
        });
        var nonUniqueTags = (0, _helper.nonUniqueArrayOfStrings)(commonTags, files.length);
        _this.initialData["tags"] = nonUniqueTags;

        _this.setState({
          tags: nonUniqueTags,
          personalTags: (0, _helper.uniqueArrayOfStringsInObject)(personalTags),
          isLoading: false,
          isGeneratingTags: false,
          tagsGenerated: true
        });
      }).catch(function (error) {
        var _error$response2 = error.response;
        _error$response2 = _error$response2 === void 0 ? {} : _error$response2;
        var _error$response2$data = _error$response2.data,
            data = _error$response2$data === void 0 ? {} : _error$response2$data;

        _this.setState({
          isLoading: false,
          isGeneratingTags: false,
          errorMessage: data.msg || error.message || error.msg || _reactI18nify.I18n.t('tagging.something_went_wrong_try_again')
        });
      });

      _this.props.setAppState({
        hasChanged: true
      });

      _this.setState({
        isLoading: true,
        isGeneratingTags: true,
        errorMessage: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setSpinner", function (value) {
      _this.setState({
        isLoading: value
      });
    });

    _defineProperty(_assertThisInitialized(_this), "goBack", function () {
      var _this$props4 = _this.props,
          _this$props4$options = _this$props4.options,
          options = _this$props4$options === void 0 ? {} : _this$props4$options,
          appState = _this$props4.appState;
      var hasChanged = appState.hasChanged;

      if (hasChanged) {
        _this.props.setPostUpload(false);

        _this.props.setAppState({
          hasChanged: false
        });
      } else _this.props.setPostUpload(false);

      if (options.closeOnEdit) _this.props.closeModal({
        hasChanged: hasChanged
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleCustomFieldChange", function (event) {
      var _this$setState;

      _this.setState((_this$setState = {}, _defineProperty(_this$setState, event.target.name, event.target.value), _defineProperty(_this$setState, "errorMessage", ''), _this$setState));

      _this.props.setAppState({
        hasChanged: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "updateProductProps", function () {
      var _this$state2 = _this.state,
          productRef = _this$state2.productRef,
          productPosition = _this$state2.productPosition;
      var _this$props5 = _this.props,
          appState = _this$props5.appState,
          files = _this$props5.files;
      var firstFile = files[0];

      _this.props.setAppState({
        hasChanged: true
      });

      _this.setState({
        isUpdatingProduct: true
      });

      (0, _api.updateProduct)(firstFile.uuid, {
        ref: productRef,
        position: productPosition
      }, appState.config).then(function () {
        _this.setState({
          oldProductPosition: productPosition || '',
          oldProductRef: productRef || '',
          isUpdatingProduct: false
        });
      }).catch(function (error) {
        var _error$response3 = error.response;
        _error$response3 = _error$response3 === void 0 ? {} : _error$response3;
        var _error$response3$data = _error$response3.data,
            data = _error$response3$data === void 0 ? {} : _error$response3$data;

        _this.setState({
          isUpdatingProduct: false,
          errorMessage: data.msg || error.message || error.msg || _reactI18nify.I18n.t('tagging.something_went_wrong_try_again')
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "transformImage", function () {
      var imageUrl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var queryOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        w: 800
      };
      var search = imageUrl.includes('?') ? '&' : '?';
      var keys = Object.keys(queryOptions);

      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];

        if (!queryOptions[key]) {
          continue;
        }

        search += "".concat(key, "=").concat(queryOptions[key]).concat(i !== keys.length - 1 ? '&' : '');
      }

      return "".concat(imageUrl).concat(search);
    });

    _defineProperty(_assertThisInitialized(_this), "getImageSrc", function (files, isImageType) {
      var sources = [];
      var isOneFile = files.length === 1;
      var cdnLinks = files.map(function (file) {
        return (0, _adjustAPI.getCDNlink)(file);
      });
      var publicLinks = files.map(function (file) {
        return (0, _adjustAPI.getPubliclink)(file);
      });

      if (isImageType && isOneFile) {
        sources = !!cdnLinks.length ? _this.transformImage(cdnLinks[0]) : (0, _utils.encodePermalink)(publicLinks);
      } else if (isImageType) {
        sources = !!cdnLinks.length ? cdnLinks.map(function (file) {
          return _this.transformImage(file);
        }) : publicLinks.map(function (file) {
          return (0, _utils.encodePermalink)(file);
        });
      } else {
        sources = (0, _icons.getFileIconSrcByType)(files[0].type);
      }

      return sources;
    });

    _defineProperty(_assertThisInitialized(_this), "checkChanges", function () {
      var isChanges = Object.keys(_this.initialData).some(function (key) {
        return key === 'tags' ? _this.initialData[key].length === _this.state[key].length ? _this.initialData[key].some(function (value, index) {
          return value !== _this.state[key][index];
        }) : true : _this.initialData[key] !== _this.state[key];
      });
      if (isChanges) _this.togglePopup();else _this.goBack();
    });

    _defineProperty(_assertThisInitialized(_this), "togglePopup", function () {
      _this.setState({
        isOpenedPopup: !_this.state.isOpenedPopup
      });
    });

    var _appState = _props.appState,
        _props$files = _props.files,
        _files = _props$files === void 0 ? [] : _props$files;

    var _appState$config3 = _appState.config,
        _appState$config3$tag = _appState$config3.tagging;
    _appState$config3$tag = _appState$config3$tag === void 0 ? {} : _appState$config3$tag;

    var _appState$config3$tag2 = _appState$config3$tag.customFields,
        _customFields = _appState$config3$tag2 === void 0 ? [] : _appState$config3$tag2,
        _language = _appState$config3.language;

    var _firstFile = _files[0];

    var _ref2 = _firstFile.product || {},
        _ref2$ref = _ref2.ref,
        _productRef = _ref2$ref === void 0 ? '' : _ref2$ref,
        _ref2$position = _ref2.position,
        _productPosition = _ref2$position === void 0 ? '' : _ref2$position;

    var date = new Date();
    var _options = {
      weekday: 'long',
      year: 'numeric',
      month: 'short',
      day: 'numeric',
      hour: '2-digit',
      minute: '2-digit'
    };
    var currentTime = date.toLocaleTimeString(_language, _options);
    _this.initialData = _this.initialData || {};
    var _customFieldsProps = {};

    if (_customFields && _customFields.length) {
      _customFieldsProps = _this.getCustomFields(_customFields, _firstFile.properties);
      _this.initialData = _objectSpread(_objectSpread({}, _this.initialData), _customFieldsProps);
    }

    _this.initialData["tags"] = [];
    _this.initialData["productRef"] = _productRef;
    _this.initialData["productPosition"] = _productPosition;
    _this.initialData["description"] = _firstFile.properties.description || '';
    _this.state = _objectSpread(_objectSpread({
      tags: [],
      personalTags: [],
      description: _firstFile.properties.description || ''
    }, _customFieldsProps), {}, {
      isLoading: false,
      isGeneratingTags: false,
      errorMessage: '',
      currentTime: currentTime,
      firstLoad: _firstFile.created_at ? new Date(_firstFile.created_at).toLocaleTimeString(_language, _options) : currentTime,
      lastModified: _firstFile.modified_at ? new Date(_firstFile.modified_at).toLocaleTimeString(_language, _options) : currentTime,
      tagsGenerated: false,
      productRef: _productRef,
      productPosition: _productPosition,
      oldProductRef: _productRef,
      oldProductPosition: _productPosition,
      isUpdatingProduct: false,
      removedTags: [],
      isOpenedPopup: false,
      tokenMetadata: {
        isEDGYMetadataVersion: true,
        isTagsField: false,
        firstFieldWithTags: {}
      }
    });
    return _this;
  }

  _createClass(TaggingTab, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props$appState = this.props.appState,
          _this$props$appState$2 = _this$props$appState.files,
          files = _this$props$appState$2 === void 0 ? [] : _this$props$appState$2,
          config = _this$props$appState.config,
          prevTab = _this$props$appState.prevTab,
          uploadedImageData = _this$props$appState.uploadedImageData,
          isClickedTagsBtn = _this$props$appState.isClickedTagsBtn;
      var _config$tagging = config.tagging;
      _config$tagging = _config$tagging === void 0 ? {} : _config$tagging;
      var executeAfterUpload = _config$tagging.executeAfterUpload;
      var firstFile = files[0];
      var isOneFile = files.length === 1;
      var isImageType = isOneFile ? (0, _icons.isImage)(firstFile.type) : (0, _icons.isAllImages)(files);
      var isPreviousGallery = prevTab === "MY_GALLERY";
      var isPreviousEditor = prevTab === 'IMAGE_EDITOR';
      this.getTokenData().then(function (tokenMetadata) {
        if (isPreviousGallery && isClickedTagsBtn || isPreviousEditor) {
          _this2.showTags(tokenMetadata);
        } else if (executeAfterUpload && !_this2.state.tags.length && isImageType && (tokenMetadata.isEDGYMetadataVersion ? tokenMetadata.isTagsField : true)) _this2.generateTags(isOneFile);else _this2.setState({
          isLoading: false
        });
      });
      if (isPreviousEditor) this.setState(uploadedImageData);
      if (this._saveMetadataBtn) this._saveMetadataBtn.focus();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.files !== prevProps.files) {
        var _this$props6 = this.props,
            appState = _this$props6.appState,
            _this$props6$files = _this$props6.files,
            files = _this$props6$files === void 0 ? {} : _this$props6$files; //const isOneFile = files.length === 1;

        var firstFile = files[0];
        var language = appState.config.language;
        var date = new Date();
        var options = {
          weekday: 'long',
          year: 'numeric',
          month: 'short',
          day: 'numeric',
          hour: '2-digit',
          minute: '2-digit'
        };
        var currentTime = date.toLocaleTimeString(language, options); //const commonTags = [];
        //const personalTags = [];
        //files.forEach(file => {
        //  file.properties = file.properties || {};
        //  file.properties.tags = file.properties.tags || [];
        //  commonTags.push(...file.properties.tags);
        //  personalTags[file.uuid] = file.properties.tags;
        //});

        this.state = {
          //tags: isOneFile ? firstFile.properties.tags : nonUniqueArrayOfStrings(commonTags, files.length),
          //personalTags: uniqueArrayOfStringsInObject(personalTags),
          description: firstFile.properties.description || '',
          isLoading: false,
          isGeneratingTags: false,
          errorMessage: '',
          currentTime: currentTime,
          firstLoad: firstFile.created_at ? new Date(firstFile.created_at).toLocaleTimeString(language, options) : '',
          lastModified: firstFile.modified_at ? new Date(firstFile.modified_at).toLocaleTimeString(language, options) : '',
          tagsGenerated: false
        };
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;

      var _this$state3 = this.state,
          productRef = _this$state3.productRef,
          productPosition = _this$state3.productPosition,
          description = _this$state3.description,
          tags = _this$state3.tags;
      var _this$props$appState$3 = this.props.appState.config.tagging;
      _this$props$appState$3 = _this$props$appState$3 === void 0 ? {} : _this$props$appState$3;
      var _this$props$appState$4 = _this$props$appState$3.customFields,
          customFields = _this$props$appState$4 === void 0 ? [] : _this$props$appState$4;
      var uploadedImageData = {
        description: description,
        productRef: productRef,
        productPosition: productPosition,
        tags: tags
      };

      if (customFields.length) {
        customFields.forEach(function (field) {
          uploadedImageData[field.metaKey] = _this3.state[field.metaKey];
        });
      }

      this.props.setAppState({
        uploadedImageData: uploadedImageData
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state4 = this.state,
          isLoading = _this$state4.isLoading,
          errorMessage = _this$state4.errorMessage,
          currentTime = _this$state4.currentTime,
          firstLoad = _this$state4.firstLoad,
          lastModified = _this$state4.lastModified,
          isGeneratingTags = _this$state4.isGeneratingTags,
          oldProductRef = _this$state4.oldProductRef,
          oldProductPosition = _this$state4.oldProductPosition,
          isUpdatingProduct = _this$state4.isUpdatingProduct,
          tags = _this$state4.tags,
          isOpenedPopup = _this$state4.isOpenedPopup,
          tokenMetadata = _this$state4.tokenMetadata;
      var _this$props7 = this.props,
          _this$props7$files = _this$props7.files,
          files = _this$props7$files === void 0 ? [] : _this$props7$files,
          appState = _this$props7.appState;
      var prevTab = appState.prevTab,
          config = appState.config,
          productsEnabled = appState.productsEnabled;
      var tagging = config.tagging,
          description = config.description,
          modifyURLButton = config.modifyURLButton;
      var _tagging$customFields2 = tagging.customFields,
          customFields = _tagging$customFields2 === void 0 ? [] : _tagging$customFields2,
          autoTaggingButton = tagging.autoTaggingButton,
          suggestionList = tagging.suggestionList;
      var isEDGYMetadataVersion = tokenMetadata.isEDGYMetadataVersion,
          isTagsField = tokenMetadata.isTagsField;

      var generateTagInfo = _reactI18nify.I18n.t('tagging.will_automatically_generate_tags');

      var firstFile = files[0];
      var isOneFile = files.length === 1;
      var isImageType = isOneFile ? (0, _icons.isImage)(firstFile.type) : (0, _icons.isAllImages)(files);
      var imageSources = this.getImageSrc(files, isImageType);
      var isSomeImageHasNoTags = files.some(function (file) {
        return file.properties.tags && !file.properties.tags.length;
      });
      return /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.TaggingTabWrapper, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.TaggingContent, null, prevTab && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.GoBack, {
        onClick: this.checkChanges
      }, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.BackIcon, null), _reactI18nify.I18n.t('tagging.go_back')), isOneFile && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.FileWrapper, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.UploadedImageWrapper, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.UploadedImage, {
        isNotImage: !isImageType,
        src: imageSources
      })), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.UploadedImageDesc, null, /*#__PURE__*/_react.default.createElement("ul", null, /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null, _reactI18nify.I18n.t('tagging.file_name'), ":"), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, firstFile.name)), /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null, _reactI18nify.I18n.t('tagging.size'), ":"), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, firstFile.size && firstFile.size.pretty ? firstFile.size.pretty : (0, _prettyBytes.default)(firstFile.size))), /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null, _reactI18nify.I18n.t('tagging.first_upload'), ":"), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, firstLoad || currentTime)), /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null, _reactI18nify.I18n.t('tagging.last_modified'), ":"), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, lastModified || currentTime)), productsEnabled && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null, _reactI18nify.I18n.t('tagging.product_ref'), ":"), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Input, {
        type: "text",
        id: 'productRef',
        key: 'productRef',
        name: 'productRef',
        placeholder: _reactI18nify.I18n.t('tagging.not_set'),
        value: this.state.productRef || '',
        onChange: this.handleCustomFieldChange
      }))), oldProductRef !== this.state.productRef && /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Button, {
        success: true,
        onClick: this.updateProductProps
      }, isUpdatingProduct ? _reactI18nify.I18n.t('tagging.updating') : _reactI18nify.I18n.t('tagging.update_product_ref')))), /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null, _reactI18nify.I18n.t('tagging.product_position'), ":"), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Input, {
        type: "text",
        id: 'productPosition',
        key: 'productPosition',
        name: 'productPosition',
        placeholder: _reactI18nify.I18n.t('tagging.not_set'),
        value: this.state.productPosition || '',
        onChange: this.handleCustomFieldChange
      }))), oldProductPosition !== this.state.productPosition && /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropValue, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Button, {
        success: true,
        onClick: this.updateProductProps
      }, isUpdatingProduct ? _reactI18nify.I18n.t('tagging.updating') : _reactI18nify.I18n.t('tagging.update_product_position')))))))), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.ContentWrapper, null, !isOneFile && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.ImagesWrapper, null, imageSources.map(function (source) {
        return /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.MultiplyImageWrapper, {
          key: source
        }, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.UploadedImageWrapper, {
          w: 20
        }, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.UploadedImage, {
          isNotImage: !isImageType,
          src: source
        })));
      })), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.InputsBlock, {
        isOneFile: isOneFile
      }, isOneFile && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, customFields.map(function (field) {
        return renderField(field, _this4.state[field.metaKey], _this4.handleCustomFieldChange);
      }), description && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Textarea, {
        value: this.state.description || '',
        placeholder: _reactI18nify.I18n.t('tagging.add_description'),
        onChange: this.handleDescriptionChange
      })), isImageType && (isEDGYMetadataVersion ? isTagsField : true) && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !isOneFile && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.PropName, null, _reactI18nify.I18n.t('tagging.common_tags')), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.TagsInputWrapper, null, /*#__PURE__*/_react.default.createElement(_reactTagsinput.default, {
        value: tags,
        renderInput: function renderInput(props) {
          return /*#__PURE__*/_react.default.createElement(_AutosuggestionInput.default, _objectSpread(_objectSpread({}, props), {}, {
            suggestionList: suggestionList
          }));
        },
        onChange: this.handleTagsChange,
        inputProps: {
          placeholder: _reactI18nify.I18n.t('tagging.add_a_tag_separate_by_pressing_enter')
        }
      }))))), errorMessage && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.ErrorWrapper, null, /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.ErrorParagraph, null, errorMessage))), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.TaggingFooter, null, autoTaggingButton && isImageType && (isEDGYMetadataVersion ? isTagsField : true) && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Button, {
        disabled: this.state.tagsGenerated,
        onClick: function onClick() {
          return _this4.generateTags(isOneFile);
        }
      }, _reactI18nify.I18n.t('tagging.generate_tags'), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.InfoIcon, {
        "data-tip": generateTagInfo
      })), /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Button, {
        ref: function ref(node) {
          return _this4._saveMetadataBtn = node;
        },
        success: true,
        onClick: this.saveMetadata.bind(this, false)
      }, _reactI18nify.I18n.t('tagging.save')), modifyURLButton && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Button, {
        success: true,
        style: {
          marginLeft: 10
        },
        onClick: this.saveMetadataAndModify
      }, _reactI18nify.I18n.t('tagging.save_and_modify'))), /*#__PURE__*/_react.default.createElement(_Spinner.Spinner, {
        show: isLoading,
        overlay: true
      }), isGeneratingTags && /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.AutoTaggingProcessLabel, null, _reactI18nify.I18n.t('tagging.auto_tagging_processing')), /*#__PURE__*/_react.default.createElement(_reactTooltip.default, {
        offset: {
          top: 0,
          right: 2
        },
        effect: "solid"
      }), isOpenedPopup && /*#__PURE__*/_react.default.createElement(_confirmPopup.default, {
        accept: _reactI18nify.I18n.t('goBackPopup.accept'),
        cancel: _reactI18nify.I18n.t('goBackPopup.cancel'),
        title: "".concat(_reactI18nify.I18n.t('goBackPopup.title'), "?"),
        msg: "".concat(_reactI18nify.I18n.t('goBackPopup.msg')),
        onClickAccept: this.goBack,
        onClickCancel: this.togglePopup
      }));
    }
  }]);

  return TaggingTab;
}(_react.Component);

var renderField = function renderField(_ref3) {
  var _ref3$type = _ref3.type,
      type = _ref3$type === void 0 ? 'text' : _ref3$type,
      _ref3$name = _ref3.name,
      name = _ref3$name === void 0 ? '' : _ref3$name,
      metaKey = _ref3.metaKey;
  var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var handler = arguments.length > 2 ? arguments[2] : undefined;

  switch (type) {
    case 'textarea':
      return /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Textarea, {
        id: metaKey,
        key: metaKey,
        name: metaKey,
        placeholder: name,
        value: value,
        onChange: handler
      });

    case 'text':
      return /*#__PURE__*/_react.default.createElement(_TaggingTabStyled.Input, {
        type: "text",
        id: metaKey,
        key: metaKey,
        name: metaKey,
        placeholder: name,
        value: value,
        onChange: handler
      });
  }
};

var _default = TaggingTab;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(TaggingTab, "TaggingTab", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\TaggingTab.js");

  __REACT_HOT_LOADER__.register(renderField, "renderField", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\TaggingTab.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\TaggingTab\\TaggingTab.js");
}();

;