"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _UserUploaderTab = require("./UserUploaderTab.styled");

var _reactI18nify = require("react-i18nify");

var _reactLoadScript = _interopRequireDefault(require("react-load-script"));

var _Spinner = require("../Spinner");

var _imageTransformation = require("../../utils/imageTransformation.utils");

var _smartcrop = _interopRequireDefault(require("smartcrop"));

var _prettyBytes = _interopRequireDefault(require("pretty-bytes"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var OPERATION = {
  SMART_CROP: 'smart_crop',
  FACE_DETECTION: 'face_detection',
  RESIZE: 'resize'
};

var PreUploadProcess = /*#__PURE__*/function (_Component) {
  _inherits(PreUploadProcess, _Component);

  var _super = _createSuper(PreUploadProcess);

  function PreUploadProcess() {
    var _this;

    _classCallCheck(this, PreUploadProcess);

    _this = _super.call(this);

    _defineProperty(_assertThisInitialized(_this), "loadedPreviewImages", 0);

    _defineProperty(_assertThisInitialized(_this), "getPreviewFileWrapperHeight", function (_ref) {
      var isAutoProcess = _ref.isAutoProcess;
      if (!_this._previewBox) return 'none';
      var columnDivider = isAutoProcess ? 4 : 2;
      return _this._previewBox.offsetWidth / columnDivider / 1.27 - 20;
    });

    _defineProperty(_assertThisInitialized(_this), "onPreviewImageLoad", function () {
      _this.loadedPreviewImages += 1;

      if (_this.loadedPreviewImages === _this.props.imagesToUpload.length - 1) {// images loaded
      }
    });

    _defineProperty(_assertThisInitialized(_this), "cropImages", function () {
      var elements = _toConsumableArray(_this._previewBox.children);

      _this.elementsLength = elements.length;
      _this.processedElements = 0;
      elements.forEach(function (wrapper) {
        var _this$state$imagesPar = _this.state.imagesParams,
            width = _this$state$imagesPar.width,
            height = _this$state$imagesPar.height;

        _smartcrop.default.crop(wrapper.children[0], {
          width: width,
          height: height,
          minScale: 1
        }, function (result) {
          _this.draw(result, wrapper.children[0]);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "resizeImages", function (callback) {
      var self = _assertThisInitialized(_this);

      var elements = _toConsumableArray(_this._previewBox.children);

      _this.elementsLength = elements.length;
      _this.processedElements = 0;
      elements.forEach(function (wrapper) {
        var _this$state$imagesPar2 = _this.state.imagesParams,
            width = _this$state$imagesPar2.width,
            height = _this$state$imagesPar2.height;
        var image = wrapper.children[0];
        new window.Caman(image, function () {
          self.processedElements += 1;

          if (!(width < image.width || height < image.height)) {
            if (self.elementsLength === self.processedElements) {
              self.setState({
                processing: false
              });
              if (callback) callback();
            }

            return;
          }

          var portraitImage = image.height > image.width;
          var resizeParams = {};

          if (width === 'auto' || height === 'auto') {
            resizeParams = {
              width: width === 'auto' ? undefined : width,
              height: height === 'auto' ? undefined : height
            };
          } else if (portraitImage) {
            resizeParams.height = height;
          } else {
            resizeParams.width = width;
          }

          this.resize(resizeParams).render(function () {
            if (self.elementsLength === self.processedElements) {
              self.setState({
                processing: false
              });
              if (callback) callback();
            }
          });
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "draw", function (result, img) {
      var _result$topCrop = result.topCrop;
      _result$topCrop = _result$topCrop === void 0 ? {} : _result$topCrop;
      var height = _result$topCrop.height,
          width = _result$topCrop.width,
          x = _result$topCrop.x,
          y = _result$topCrop.y;

      var self = _assertThisInitialized(_this);

      new window.Caman(img, function () {
        self.processedElements += 1;
        this.crop(width, height, x, y);
        this.resize({
          width: self.state.imagesParams.width,
          height: self.state.imagesParams.height
        });
        this.render();

        if (self.elementsLength === self.processedElements) {
          self.setState({
            processing: false
          });
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "updateImagesParams", function (event) {
      _this.setState({
        imagesParams: _objectSpread(_objectSpread({}, _this.state.imagesParams), {}, _defineProperty({}, event.target.name, event.target.value))
      });
    });

    _defineProperty(_assertThisInitialized(_this), "resetCanvasImages", function () {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
      _this.loadedPreviewImages = 0;

      var nextImagesToUpload = _toConsumableArray(_this.props.imagesToUpload);

      _this.props.updateImagesToUpload(nextImagesToUpload, callback);
    });

    _defineProperty(_assertThisInitialized(_this), "applyTransformations", function () {
      _this.setState({
        processing: true
      });

      _this.resetCanvasImages(_this.getCurrentOperationCallback());
    });

    _defineProperty(_assertThisInitialized(_this), "getCurrentOperationCallback", function () {
      switch (_this.state.operation) {
        case OPERATION.SMART_CROP:
          return _this.cropImages;

        case OPERATION.FACE_DETECTION:
          return _this.aceDetectionOpenCV;

        case OPERATION.RESIZE:
          return _this.resizeImages;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "showCropResizeMenu", function () {
      _this.setState({
        processing: true,
        cropResizeMenu: true
      }, _this.cropImages);
    });

    _defineProperty(_assertThisInitialized(_this), "onRest", function () {
      _this.setState({
        cropResizeMenu: false,
        operation: OPERATION.SMART_CROP
      });

      _this.resetCanvasImages();
    });

    _defineProperty(_assertThisInitialized(_this), "activateFaceDetection", function () {
      var size = {};

      _this.setState({
        processing: true
      });

      if (_this.state.operation === OPERATION.RESIZE) {
        size = {
          width: 300,
          height: 300
        };
      }

      _this.resetCanvasImages(function () {
        _this.setState({
          operation: OPERATION.FACE_DETECTION,
          operationOpen: false,
          imagesParams: _objectSpread(_objectSpread({}, _this.state.imagesParams), size)
        }, function () {
          _this.aceDetectionOpenCV();
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "activateSmartCrop", function () {
      var size = {};

      _this.setState({
        processing: true
      });

      if (_this.state.operation === OPERATION.RESIZE) {
        size = {
          width: 300,
          height: 300
        };
      }

      _this.resetCanvasImages(function () {
        _this.setState({
          operation: OPERATION.SMART_CROP,
          operationOpen: false,
          imagesParams: _objectSpread(_objectSpread({}, _this.state.imagesParams), size)
        }, _this.cropImages);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "activateResize", function () {
      _this.setState({
        processing: true
      });

      _this.resetCanvasImages(function () {
        _this.setState({
          operation: OPERATION.RESIZE,
          operationOpen: false,
          imagesParams: _objectSpread(_objectSpread({}, _this.state.imagesParams), {}, {
            height: 'auto'
          })
        }, _this.resizeImages);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "prescaleImage", function (image, maxDimension, callback) {
      var width = image.naturalWidth || image.width;
      var height = image.naturalHeight || image.height;
      if (width < maxDimension && height < maxDimension) return callback(image, 1);
      var scale = Math.min(maxDimension / width, maxDimension / height);
      var canvas = document.createElement('canvas');
      canvas.width = ~~(width * scale);
      canvas.height = ~~(height * scale);
      canvas.getContext('2d').drawImage(image, 0, 0, canvas.width, canvas.height);
      var result = document.createElement('img');

      result.onload = function () {
        callback(result, scale);
      };

      result.src = canvas.toDataURL();
    });

    _defineProperty(_assertThisInitialized(_this), "aceDetectionOpenCV", function () {
      var _this$state$imagesPar3 = _this.state.imagesParams,
          width = _this$state$imagesPar3.width,
          height = _this$state$imagesPar3.height;

      var elements = _toConsumableArray(_this._previewBox.children);

      var self = _assertThisInitialized(_this);

      _this.processedElements = 0;
      var result = [];
      var options = {
        width: width * 1,
        height: height * 1,
        minScale: 0.2
      };
      elements.forEach(function (wrapper, index) {
        var img = wrapper.children[0];
        var nextOptions = options;

        _this.prescaleImage(img, 768, function (img, scale) {
          var src = window.cv.imread(img);
          var gray = new window.cv.Mat();
          window.cv.cvtColor(src, gray, window.cv.COLOR_RGBA2GRAY, 0);
          var faces = new window.cv.RectVector();
          var faceCascade = new window.cv.CascadeClassifier(); // load pre-trained classifiers

          faceCascade.load('haarcascade_frontalface_default.xml'); // detect faces

          var msize = new window.cv.Size(0, 0); // let c = document.createElement('canvas');
          // cv.imshow(c, gray);
          // document.body.appendChild(c)

          faceCascade.detectMultiScale(gray, faces, 1.1, 3, 0, msize, msize);
          nextOptions.boost = [];

          for (var i = 0; i < faces.size(); ++i) {
            var face = faces.get(i);
            nextOptions.boost.push({
              x: face.x / scale,
              y: face.y / scale,
              width: face.width / scale,
              height: face.height / scale,
              weight: 1.0
            });
          }

          src.delete();
          gray.delete();
          faceCascade.delete();
          faces.delete();
          result.push(nextOptions);
          var image = self._previewBox.children[index].children[0];

          _smartcrop.default.crop(image, nextOptions, function (result) {
            self.draw(result, image);
          });
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onLoadCaman", function () {
      var config = _this.props.appState.config;

      if (_this._transformAndUploadBtn) {
        _this._transformAndUploadBtn.focus();
      }

      if (config.processBeforeUpload && config.processBeforeUpload.operation === 'resize') {
        var _config$processBefore = config.processBeforeUpload,
            widthLimit = _config$processBefore.widthLimit,
            heightLimit = _config$processBefore.heightLimit;

        _this.setState({
          cropResizeMenu: true,
          camanLoaded: true,
          imagesParams: {
            width: widthLimit,
            height: heightLimit
          }
        }, function () {
          _this.resizeImages(_this.applyTransformationsAndUpload);
        });
      } else {
        _this.setState({
          camanLoaded: true
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onOpenCVLoad", function () {
      if (window.__loadCascade) {
        _this.setState({
          faceDetectionLoaded: true
        });

        return;
      }

      window.__loadCascade = true;

      _this.loadCascade('haarcascade_frontalface_default.xml', 'https://unpkg.com/opencv.js@1.2.1/tests/haarcascade_frontalface_default.xml', function () {
        _this.setState({
          faceDetectionLoaded: true
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "loadCascade", function (path, url, callback) {
      var request = new XMLHttpRequest();
      request.open('GET', url, true);
      request.responseType = 'arraybuffer';

      request.onload = function () {
        if (request.readyState === 4) {
          if (request.status === 200) {
            var data = new Uint8Array(request.response);
            window.cv.FS_createDataFile('/', path, data, true, false, false);
            callback();
          } else {
            self.printError('Failed to load ' + url + ' status: ' + request.status);
          }
        }
      };

      request.send();
    });

    _defineProperty(_assertThisInitialized(_this), "applyTransformationsAndUpload", function () {
      if (!_this.state.cropResizeMenu) {
        _this.props.upload();

        return;
      }

      var elements = _toConsumableArray(_this._previewBox.children).map(function (wrapper) {
        return wrapper.children[0];
      });

      var files = [];

      var self = _assertThisInitialized(_this);

      var imagesLength = elements.length;
      var processedImages = 0;
      elements.forEach(function (canvas, index) {
        new window.Caman(canvas, function () {
          this.render(function () {
            var contentType = self.props.imagesToUpload[index].file.type;
            var base64 = this.canvas.toDataURL(contentType);
            var block = base64.split(";");
            var realData = block[1].split(",")[1];
            var blob = (0, _imageTransformation.b64toBlob)(realData, contentType, null);
            blob.name = self.props.imagesToUpload[index].file.name;
            files.push(blob);
            processedImages += 1;

            if (imagesLength === processedImages) {
              self.props.updateFilesAndUpload(files);
            }
          });
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onOperationInputFocus", function (event) {
      if (_this.state.operation === OPERATION.RESIZE) {
        var _imagesParams;

        var oppositeProp = event.target.name === 'height' ? 'width' : 'height';
        if (_this.state.imagesParams[oppositeProp] === 'auto') return;

        _this.setState({
          imagesParams: (_imagesParams = {}, _defineProperty(_imagesParams, event.target.name, 300), _defineProperty(_imagesParams, oppositeProp, 'auto'), _imagesParams)
        });
      }
    });

    _this.state = {
      cropResizeMenu: false,
      faceDetectionLoaded: false,
      previewBoxParams: {
        width: 'auto',
        height: 'auto'
      },
      imagesParams: {
        width: 300,
        height: 300
      },
      operation: OPERATION.SMART_CROP,
      processing: false,
      camanLoaded: false
    };
    return _this;
  }

  _createClass(PreUploadProcess, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.setState({
        operation: OPERATION.SMART_CROP
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          cropResizeMenu = _this$state.cropResizeMenu,
          operationOpen = _this$state.operationOpen,
          operation = _this$state.operation,
          faceDetectionLoaded = _this$state.faceDetectionLoaded,
          imagesParams = _this$state.imagesParams,
          processing = _this$state.processing,
          camanLoaded = _this$state.camanLoaded;
      var _this$props = this.props,
          imagesToUpload = _this$props.imagesToUpload,
          appState = _this$props.appState;
      var isAutoProcess = appState.config.processBeforeUpload;
      var previewHeight = this.getPreviewFileWrapperHeight({
        isAutoProcess: isAutoProcess
      });
      var size = (0, _prettyBytes.default)(imagesToUpload.reduce(function (accumulator, image) {
        return accumulator + image.file.size;
      }, 0));
      var oneImage = imagesToUpload.length === 1;
      return /*#__PURE__*/_react.default.createElement(_UserUploaderTab.Container, {
        noBorder: true
      }, /*#__PURE__*/_react.default.createElement(_UserUploaderTab.PreviewFiles, {
        isAutoProcess: isAutoProcess,
        ref: function ref(node) {
          return _this2._previewBox = node;
        },
        oneImage: oneImage
      }, imagesToUpload.map(function (image, index) {
        return /*#__PURE__*/_react.default.createElement(_UserUploaderTab.PreviewFileWrapper, {
          key: index,
          oneImage: oneImage,
          isAutoProcess: isAutoProcess,
          h: previewHeight === 'none' ? 'none' : parseInt(previewHeight)
        }, /*#__PURE__*/_react.default.createElement("img", {
          src: image.src,
          alt: "",
          onLoad: _this2.onPreviewImageLoad
        }), /*#__PURE__*/_react.default.createElement("div", null, image.file.name));
      })), !isAutoProcess && /*#__PURE__*/_react.default.createElement("div", {
        style: {
          width: '350px',
          maxHeight: '100%',
          overflow: 'hidden',
          overflowY: 'auto'
        }
      }, cropResizeMenu && /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_UserUploaderTab.PreviewLabel, {
        htmlFor: "operation"
      }, "Operation"), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.TransformationList, {
        name: "operation",
        onMouseLeave: function onMouseLeave() {
          _this2.setState({
            operationOpen: false
          });
        }
      }, /*#__PURE__*/_react.default.createElement(_UserUploaderTab.ActiveOperation, {
        as: "div",
        className: "active-option".concat(operationOpen ? ' active' : ''),
        onClick: function onClick() {
          _this2.setState({
            operationOpen: !_this2.state.operationOpen
          });
        }
      }, _reactI18nify.I18n.t("upload.".concat(operation))), /*#__PURE__*/_react.default.createElement("div", {
        className: "options".concat(operationOpen ? ' active' : '')
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "item".concat(operation === OPERATION.SMART_CROP ? ' active' : ''),
        onClick: this.activateSmartCrop
      }, _reactI18nify.I18n.t('upload.smart_crop')), /*#__PURE__*/_react.default.createElement("div", {
        className: "item".concat(operation === OPERATION.FACE_DETECTION ? ' active' : '').concat(!faceDetectionLoaded ? ' disabled' : ''),
        onClick: this.activateFaceDetection
      }, _reactI18nify.I18n.t('upload.face_detection'), " ", /*#__PURE__*/_react.default.createElement(_Spinner.Spinner, {
        fz: "4px",
        show: !faceDetectionLoaded
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "item".concat(operation === OPERATION.RESIZE ? ' active' : ''),
        onClick: this.activateResize
      }, _reactI18nify.I18n.t('upload.resize')))), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.PreviewLabel, {
        htmlFor: "width"
      }, _reactI18nify.I18n.t("upload.width")), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.OperationInput, {
        name: "width",
        value: imagesParams.width,
        onClick: this.onOperationInputFocus,
        onChange: this.updateImagesParams
      }), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.PreviewLabel, {
        htmlFor: "height"
      }, _reactI18nify.I18n.t("upload.height")), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.OperationInput, {
        name: "height",
        value: imagesParams.height,
        onClick: this.onOperationInputFocus,
        onChange: this.updateImagesParams
      }), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_UserUploaderTab.ButtonApplyTransforms, {
        key: "reset",
        className: "ae-btn",
        style: {
          marginRight: 10
        },
        onClick: this.onRest
      }, _reactI18nify.I18n.t("upload.revert")), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.ButtonApplyTransforms, {
        key: "apply",
        className: "ae-btn",
        onClick: this.applyTransformations
      }, _reactI18nify.I18n.t("upload.apply")))), !cropResizeMenu && /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_UserUploaderTab.ButtonApplyTransforms, {
        key: "crop_resize",
        className: "ae-btn",
        style: {
          width: 300
        },
        onClick: this.showCropResizeMenu
      }, _reactI18nify.I18n.t("upload.crop_and_resize")), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.ButtonApplyTransforms, {
        key: "cancel",
        className: "ae-btn",
        style: {
          width: 300
        },
        onClick: this.props.cancelUpload
      }, _reactI18nify.I18n.t("upload.cancel"))), /*#__PURE__*/_react.default.createElement(_UserUploaderTab.ButtonAction, {
        ref: function ref(node) {
          return _this2._transformAndUploadBtn = node;
        },
        key: "ok",
        className: "ae-btn",
        style: {
          width: 300
        },
        autofocus: true,
        onClick: this.applyTransformationsAndUpload,
        onKeyDown: function onKeyDown(ev) {
          return (0, _utils.isEnterClick)(ev) && _this2.applyTransformationsAndUpload();
        }
      }, _reactI18nify.I18n.t('upload.upload_btn')), /*#__PURE__*/_react.default.createElement("div", {
        style: {
          marginTop: '5px'
        }
      }, /*#__PURE__*/_react.default.createElement("p", null, _reactI18nify.I18n.t('upload.selected_files'), ": ", imagesToUpload.length, ", ", _reactI18nify.I18n.t('upload.total_size'), ": ", size))), (processing || !camanLoaded || isAutoProcess) && /*#__PURE__*/_react.default.createElement(_Spinner.Spinner, {
        overlay: true,
        show: true
      }), !isAutoProcess && /*#__PURE__*/_react.default.createElement(_reactLoadScript.default, {
        onLoad: this.onOpenCVLoad,
        url: "https://unpkg.com/opencv.js@1.2.1/opencv.js",
        integrity: "sha384-ucXOxPgA5tSKdaZgFD+5C0lAJeavjW31veENhNvOwsTjgx8waDD0s1QcMdUxhlxk",
        crossorigin: "anonymous"
      }), /*#__PURE__*/_react.default.createElement(_reactLoadScript.default, {
        onLoad: this.onLoadCaman,
        url: "https://scaleflex.cloudimg.io/v7/plugins/caman-sfx/caman-sfx.min.js?v=ab5b69&func=proxy",
        crossorigin: "anonymous"
      }));
    }
  }]);

  return PreUploadProcess;
}(_react.Component);

var _default = PreUploadProcess;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(OPERATION, "OPERATION", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadImagesTab\\PreUploadProcess.js");

  __REACT_HOT_LOADER__.register(PreUploadProcess, "PreUploadProcess", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadImagesTab\\PreUploadProcess.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadImagesTab\\PreUploadProcess.js");
}();

;