"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.processExtensions = exports.validateExtensions = void 0;

var _reactI18nify = require("react-i18nify");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var validateExtensions = function validateExtensions(files, configExtensions, showAlert, isFromWeb) {
  if (!configExtensions.length) return true;

  var _checkIsValidExtensio = checkIsValidExtension(files, configExtensions, isFromWeb),
      isValid = _checkIsValidExtensio.isValid,
      _checkIsValidExtensio2 = _checkIsValidExtensio.invalidExtensions,
      invalidExtensions = _checkIsValidExtensio2 === void 0 ? '' : _checkIsValidExtensio2;

  if (isValid) {
    return true;
  } else if (!isValid && files) {
    var alert = "".concat(_reactI18nify.I18n.t('upload.invalid_file_extension')).concat(invalidExtensions ? ": ".concat(invalidExtensions, ". ") + "".concat(_reactI18nify.I18n.t('upload.accepted_file_types'), ": ").concat(processExtensions(configExtensions).join(', '), ".") : '');
    showAlert('', alert, 'warning');
    return false;
  } else return false;
};

exports.validateExtensions = validateExtensions;

var checkIsValidExtension = function checkIsValidExtension(files, userExtensions) {
  var isFromWeb = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var nextUserExtensions = processExtensions(userExtensions);
  var invalidExtensions = [];
  var filesExtensions = isFromWeb ? [files.split('.').pop()] : _toConsumableArray(files).map(function (file) {
    return file.type.split('/').pop();
  });
  var isValid = filesExtensions.every(function (ext) {
    return nextUserExtensions.some(function (userExt) {
      return ext.includes(userExt);
    });
  });
  filesExtensions.forEach(function (file) {
    if (!nextUserExtensions.includes(file)) invalidExtensions.push(file);
  });
  return {
    isValid: isValid,
    invalidExtensions: invalidExtensions.join(", ")
  };
};

var processExtensions = function processExtensions(userExtensions) {
  var nextUserExtensions = [];
  if (userExtensions.includes('jpeg')) nextUserExtensions = [].concat(_toConsumableArray(userExtensions), ['jpg']);else if (userExtensions.includes('jpg')) nextUserExtensions = [].concat(_toConsumableArray(userExtensions), ['jpeg']);
  return nextUserExtensions;
};

exports.processExtensions = processExtensions;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(validateExtensions, "validateExtensions", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadImagesTab\\UserUploaderTab.utils.js");

  __REACT_HOT_LOADER__.register(checkIsValidExtension, "checkIsValidExtension", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadImagesTab\\UserUploaderTab.utils.js");

  __REACT_HOT_LOADER__.register(processExtensions, "processExtensions", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadImagesTab\\UserUploaderTab.utils.js");
}();

;