"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _folderManager = require("./folderManager.styled");

var _FolderItem = _interopRequireDefault(require("./FolderItem"));

var _reactI18nify = require("react-i18nify");

var _breadCrumbs = _interopRequireDefault(require("./bread-crumbs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FolderManager = /*#__PURE__*/function (_Component) {
  _inherits(FolderManager, _Component);

  var _super = _createSuper(FolderManager);

  function FolderManager() {
    var _this;

    _classCallCheck(this, FolderManager);

    _this = _super.call(this);

    _defineProperty(_assertThisInitialized(_this), "toggleSideMenu", function () {
      var showFileManager = !_this.state.showFileManager;

      _this.setState({
        showFileManager: showFileManager
      });
    });

    _this.state = {
      showFileManager: false
    };
    return _this;
  }

  _createClass(FolderManager, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var showFileManager = this.state.showFileManager;
      var _this$props = this.props,
          _this$props$folders = _this$props.folders,
          folders = _this$props$folders === void 0 ? [] : _this$props$folders,
          path = _this$props.path,
          rootDir = _this$props.rootDir,
          isLoading = _this$props.isLoading;
      return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_folderManager.FolderToggleWrapper, {
        onClick: this.toggleSideMenu
      }, /*#__PURE__*/_react.default.createElement(_folderManager.FolderIcon, null), /*#__PURE__*/_react.default.createElement(_breadCrumbs.default, {
        path: path
      })), /*#__PURE__*/_react.default.createElement(_folderManager.FolderManagerWrapper, {
        showFileManager: showFileManager
      }, path && path !== rootDir && !isLoading && /*#__PURE__*/_react.default.createElement(_folderManager.Folder, {
        onClick: this.props.goToLevelUpFolder
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "btn-back"
      }), /*#__PURE__*/_react.default.createElement(_folderManager.Folder.Name, {
        title: _reactI18nify.I18n.t('file_manager.go_back')
      }, '../')), !isLoading && folders.map(function (folder) {
        return /*#__PURE__*/_react.default.createElement(_FolderItem.default, {
          key: folder.uuid,
          folder: folder,
          changeFolder: _this2.props.changeFolder
        });
      }), !isLoading && folders.length === 0 && /*#__PURE__*/_react.default.createElement(_folderManager.EmptyNote, null, _reactI18nify.I18n.t('file_manager.no_subfolders'))), /*#__PURE__*/_react.default.createElement(_folderManager.Overlay, {
        show: showFileManager,
        onClick: this.toggleSideMenu
      }));
    }
  }]);

  return FolderManager;
}(_react.Component);

var _default = FolderManager;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FolderManager, "FolderManager", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadedImagesTab\\folderManager\\FolderManager.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\UploadedImagesTab\\folderManager\\FolderManager.js");
}();

;