"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactVirtualized = require("react-virtualized");

var _Masonry = require("react-virtualized/dist/es/Masonry");

var ImageGridService = _interopRequireWildcard(require("../services/imageGrid.service"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactVirtualizedImagesGrid = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(ReactVirtualizedImagesGrid, _React$PureComponent);

  var _super = _createSuper(ReactVirtualizedImagesGrid);

  function ReactVirtualizedImagesGrid(props) {
    var _this;

    _classCallCheck(this, ReactVirtualizedImagesGrid);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "_calculateColumnCount", function () {
      var _this$state = _this.state,
          columnWidth = _this$state.columnWidth,
          gutterSize = _this$state.gutterSize;
      _this._columnCount = ImageGridService.getColumnCount(_this._width, columnWidth, gutterSize);
    });

    _defineProperty(_assertThisInitialized(_this), "_cellRenderer", function (_ref) {
      var index = _ref.index,
          key = _ref.key,
          parent = _ref.parent,
          style = _ref.style;
      var _this$props = _this.props,
          list = _this$props.list,
          cellContent = _this$props.cellContent;
      var columnWidth = _this.state.columnWidth;
      var item = list[index];
      return /*#__PURE__*/React.createElement(_reactVirtualized.CellMeasurer, {
        cache: _this._cache,
        index: index,
        key: key,
        parent: parent
      }, cellContent({
        style: style,
        columnWidth: columnWidth,
        item: item,
        index: index,
        key: key
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "_initCellPositioner", function () {
      if (typeof _this._cellPositioner === 'undefined') {
        var _this$state2 = _this.state,
            columnWidth = _this$state2.columnWidth,
            gutterSize = _this$state2.gutterSize;
        _this._cellPositioner = (0, _Masonry.createCellPositioner)({
          cellMeasurerCache: _this._cache,
          columnCount: _this._columnCount,
          columnWidth: columnWidth,
          spacer: gutterSize
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_onResize", function (_ref2) {
      var width = _ref2.width;
      if (width) _this._width = width;

      _this._calculateColumnCount();

      _this._resetCellPositioner();

      _this._setMasonryRef.recomputeCellPositions();
    });

    _defineProperty(_assertThisInitialized(_this), "_renderAutoSizer", function (_ref3) {
      var height = _ref3.height,
          scrollTop = _ref3.scrollTop;
      _this._height = height;
      _this._scrollTop = scrollTop;
      var overscanByPixels = _this.state.overscanByPixels;
      return /*#__PURE__*/React.createElement(_reactVirtualized.AutoSizer, {
        ref: function ref(node) {
          return _this.child = node;
        },
        disableHeight: true,
        height: height,
        onResize: _this._onResize,
        overscanByPixels: overscanByPixels,
        scrollTop: _this._scrollTop
      }, _this._renderMasonry);
    });

    _defineProperty(_assertThisInitialized(_this), "onScroll", function (_ref4) {
      var clientHeight = _ref4.clientHeight,
          scrollHeight = _ref4.scrollHeight,
          scrollTop = _ref4.scrollTop;

      var self = _assertThisInitialized(_this);

      var _this$props2 = _this.props,
          isShowMoreImages = _this$props2.isShowMoreImages,
          onShowMoreImages = _this$props2.onShowMoreImages,
          getImageGridWrapperPosition = _this$props2.getImageGridWrapperPosition;
      if (getImageGridWrapperPosition) getImageGridWrapperPosition();
      if (!onShowMoreImages) return;

      if (clientHeight + scrollTop + 600 >= scrollHeight && !isShowMoreImages) {
        _this.props.onShowMoreImages(function () {
          var resizeTriggers = document.querySelector('div.resize-triggers').parentNode;
          if (resizeTriggers.style.paddingLeft === '9px') resizeTriggers.style.paddingLeft = '10px';else resizeTriggers.style.paddingLeft = '9px';
          if (resizeTriggers.style.paddingRight === '9px') resizeTriggers.style.paddingRight = '10px';else resizeTriggers.style.paddingRight = '9px';

          self.child._onResize();
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getCoordinates", function (index) {
      var _this$props3 = _this.props,
          imageGridWrapperWidth = _this$props3.imageGridWrapperWidth,
          ratio = _this$props3.ratio,
          _this$props3$addition = _this$props3.additionalImageHeight,
          additionalImageHeight = _this$props3$addition === void 0 ? 0 : _this$props3$addition;
      var _this$state3 = _this.state,
          columnWidth = _this$state3.columnWidth,
          gutterSize = _this$state3.gutterSize;
      var perRow = _this._columnCount || Math.floor(imageGridWrapperWidth / columnWidth);
      var row = Math.floor(index / perRow);
      var indexInRow = index % perRow;
      return {
        top: Math.floor(columnWidth / ratio + gutterSize + additionalImageHeight) * row,
        left: (columnWidth + gutterSize) * indexInRow
      };
    });

    _defineProperty(_assertThisInitialized(_this), "_renderMasonry", function (_ref5) {
      var width = _ref5.width;
      _this._width = width;

      _this._calculateColumnCount();

      _this._initCellPositioner();

      var _this$props4 = _this.props,
          count = _this$props4.count,
          customPositionHandler = _this$props4.customPositionHandler;
      var _this$state4 = _this.state,
          height = _this$state4.height,
          overscanByPixels = _this$state4.overscanByPixels,
          windowScrollerEnabled = _this$state4.windowScrollerEnabled;
      return /*#__PURE__*/React.createElement(_reactVirtualized.Masonry, {
        id: "image-grid-wrapper",
        autoHeight: windowScrollerEnabled,
        cellCount: count,
        cellMeasurerCache: _this._cache,
        cellPositioner: customPositionHandler ? _this.getCoordinates : _this._cellPositioner,
        cellRenderer: _this._cellRenderer,
        height: windowScrollerEnabled ? _this._height : height,
        overscanByPixels: overscanByPixels,
        ref: function ref(node) {
          return _this._setMasonryRef = node;
        },
        scrollTop: _this._scrollTop,
        width: width,
        onScroll: _this.onScroll,
        tabIndex: -1,
        onCellsRendered: _this.props.getImageGridWrapperPosition
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_resetCellPositioner", function () {
      var _this$state5 = _this.state,
          columnWidth = _this$state5.columnWidth,
          gutterSize = _this$state5.gutterSize;

      _this._cellPositioner.reset({
        columnCount: _this._columnCount,
        columnWidth: columnWidth,
        spacer: gutterSize
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_setMasonryRef", function (node) {
      _this._masonry = node;
    });

    _this._columnWidth = props.columnWidth || 200;
    _this._gutterSize = props.gutterSize || 10;
    _this._columnCount = 0;
    _this._cache = new _reactVirtualized.CellMeasurerCache({
      defaultHeight: Math.floor(props.imageContainerHeight) || 300,
      defaultWidth: Math.floor(_this._columnWidth),
      fixedWidth: false
    });
    _this.state = {
      columnWidth: Math.floor(_this._columnWidth),
      height: Math.floor(props.imageContainerHeight) || 300,
      gutterSize: _this._gutterSize,
      overscanByPixels: 0,
      windowScrollerEnabled: false
    };
    return _this;
  }

  _createClass(ReactVirtualizedImagesGrid, [{
    key: "render",
    value: function render() {
      var _this$state6 = this.state,
          overscanByPixels = _this$state6.overscanByPixels,
          windowScrollerEnabled = _this$state6.windowScrollerEnabled,
          height = _this$state6.height;
      var child;

      if (windowScrollerEnabled) {
        child = /*#__PURE__*/React.createElement(_reactVirtualized.WindowScroller, {
          overscanByPixels: overscanByPixels
        }, this._renderAutoSizer);
      } else {
        child = this._renderAutoSizer({
          height: height
        });
      }

      return child;
    }
  }]);

  return ReactVirtualizedImagesGrid;
}(React.PureComponent);

var _default = ReactVirtualizedImagesGrid;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(ReactVirtualizedImagesGrid, "ReactVirtualizedImagesGrid", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\VirtualizedImagesGrid.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\VirtualizedImagesGrid.js");
}();

;