"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _confirmPopup = require("./confirm-popup.styled");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ConfirmPopup = function ConfirmPopup(props) {
  var onClickAccept = props.onClickAccept,
      onClickCancel = props.onClickCancel,
      accept = props.accept,
      cancel = props.cancel,
      title = props.title,
      msg = props.msg;

  var onClickOverlay = function onClickOverlay(event) {
    if (event.target.className.includes('dialog')) onClickCancel();
  };

  return /*#__PURE__*/_react.default.createElement(_confirmPopup.Overlay, {
    onClick: onClickOverlay
  }, /*#__PURE__*/_react.default.createElement(_confirmPopup.Dialog, {
    className: "dialog"
  }, /*#__PURE__*/_react.default.createElement(_confirmPopup.Content, null, /*#__PURE__*/_react.default.createElement(_confirmPopup.Header, null, /*#__PURE__*/_react.default.createElement(_confirmPopup.Title, null, title), /*#__PURE__*/_react.default.createElement(_confirmPopup.CloseButton, {
    type: "button",
    onClick: onClickCancel
  }, /*#__PURE__*/_react.default.createElement("span", null, "\xD7"))), /*#__PURE__*/_react.default.createElement(_confirmPopup.Body, null, /*#__PURE__*/_react.default.createElement("p", null, msg)), /*#__PURE__*/_react.default.createElement(_confirmPopup.Footer, null, /*#__PURE__*/_react.default.createElement(_confirmPopup.Button, {
    type: "button",
    onClick: onClickAccept
  }, accept), /*#__PURE__*/_react.default.createElement(_confirmPopup.CancelButton, {
    type: "button",
    onClick: onClickCancel
  }, cancel)))));
};

ConfirmPopup.propTypes = {
  onClickCancel: _propTypes.default.func.isRequired,
  onClickAccept: _propTypes.default.func.isRequired,
  accept: _propTypes.default.string,
  cancel: _propTypes.default.string,
  title: _propTypes.default.string,
  msg: _propTypes.default.string
};
var _default = ConfirmPopup;
var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(ConfirmPopup, "ConfirmPopup", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\confirm-popup\\confirm-popup.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\confirm-popup\\confirm-popup.js");
}();

;