"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _filerobotImageEditor = _interopRequireDefault(require("filerobot-image-editor"));

var _adjustAPI = require("../../utils/adjustAPI.utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var goBack = function goBack(prevTab, setPostUpload) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var closeModal = arguments.length > 3 ? arguments[3] : undefined;

  if (options.closeOnEdit) {
    closeModal();
    return;
  }

  if (prevTab === 'TAGGING') setPostUpload(true, 'TAGGING', 'IMAGE_EDITOR');else setPostUpload(false);
};

var uploadFiles = function uploadFiles(prevTab, url, file, saveUploadedFiles, setPostUpload) {
  var options = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
  var closeModal = arguments.length > 6 ? arguments[6] : undefined;
  var uploadHandler = arguments.length > 7 ? arguments[7] : undefined;
  var files = [_objectSpread(_objectSpread({}, file), {}, {
    public_link: (0, _adjustAPI.getPubliclink)(file)
  })];
  uploadHandler(files, {
    stage: 'edit'
  });

  if (options.closeOnEdit) {
    closeModal();
    return;
  }

  if (prevTab === 'TAGGING') {
    var _files = [_objectSpread(_objectSpread({}, file), {}, {
      public_link: (0, _adjustAPI.getPubliclink)(file)
    })];
    saveUploadedFiles(_files);
    setPostUpload(true, 'TAGGING');
  } else setPostUpload(false);
};

var _default = function _default(_ref) {
  var appState = _ref.appState,
      _ref$files = _ref.files;
  _ref$files = _ref$files === void 0 ? {} : _ref$files;

  var _ref$files2 = _slicedToArray(_ref$files, 1),
      _ref$files2$ = _ref$files2[0],
      file = _ref$files2$ === void 0 ? {} : _ref$files2$,
      path = _ref.path,
      saveUploadedFiles = _ref.saveUploadedFiles,
      setPostUpload = _ref.setPostUpload,
      options = _ref.options,
      closeModal = _ref.closeModal;

  var prevTab = appState.prevTab,
      config = appState.config,
      modifyURL = appState.modifyURL;
  var uploadKey = config.uploadKey,
      baseAPI = config.baseAPI,
      container = config.container,
      uploadParams = config.uploadParams,
      cloudimageToken = config.cloudimageToken,
      uploadHandler = config.uploadHandler,
      language = config.language,
      _config$imageEditorCo = config.imageEditorConfig,
      imageEditorConfig = _config$imageEditorCo === void 0 ? {} : _config$imageEditorCo;
  var isGif = (0, _adjustAPI.getPubliclink)(file).slice(-3).toLowerCase() === 'gif';
  var src = (0, _adjustAPI.getCDNlink)(file);

  var onComplete = function onComplete(url) {
    if (modifyURL) {
      var files = [_objectSpread(_objectSpread({}, file), {}, {
        modified_url: url,
        public_link: (0, _adjustAPI.getPubliclink)(file)
      })];
      uploadHandler(files, {
        stage: 'modify'
      });
      closeModal();
    } else {
      uploadFiles(prevTab, url, file, saveUploadedFiles, setPostUpload, options, closeModal, uploadHandler);
    }
  };

  var imageEditorImageInfo = {
    imageProperties: file.properties,
    imageMeta: file.meta,
    imageName: file.name
  };
  return /*#__PURE__*/_react.default.createElement(_filerobotImageEditor.default, {
    show: true,
    config: _objectSpread(_objectSpread({
      isLowQualityPreview: true,
      colorScheme: 'dark',
      language: language,
      processWithCloudimage: isGif || modifyURL,
      uploadWithCloudimageLink: modifyURL ? !modifyURL : isGif
    }, imageEditorConfig), {}, {
      filerobot: _objectSpread(_objectSpread({
        baseAPI: baseAPI,
        token: container,
        uploadKey: uploadKey,
        container: container,
        uploadParams: _objectSpread(_objectSpread({}, uploadParams), {}, {
          dir: path || uploadParams.dir
        }, imageEditorConfig.filerobot && imageEditorConfig.filerobot.uploadParams)
      }, imageEditorConfig.filerobot), imageEditorImageInfo),
      cloudimage: _objectSpread({
        token: cloudimageToken
      }, imageEditorConfig.cloudimage),
      showGoBackBtn: true
    }),
    closeOnLoad: false,
    src: src,
    onComplete: onComplete,
    onClose: function onClose() {
      goBack(prevTab, setPostUpload, options, closeModal);
    },
    showInModal: false
  });
};

var _default2 = _default;
exports.default = _default2;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(goBack, "goBack", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\imageEditor\\ImageEditorWrapper.js");

  __REACT_HOT_LOADER__.register(uploadFiles, "uploadFiles", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\imageEditor\\ImageEditorWrapper.js");

  __REACT_HOT_LOADER__.register(_default, "default", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\components\\imageEditor\\ImageEditorWrapper.js");
}();

;