"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCropImageUrl = exports.getFitResizeImageUrl = exports.getFitResizeImageUrlWithCIcdn = exports.getResizeImageUrl = exports.getActualColumnWidth = exports.getColumnWidth = exports.getColumnCount = void 0;

var getColumnCount = function getColumnCount(containerWidth, columnWidth, gutterSize) {
  return Math.floor((containerWidth + gutterSize) / (columnWidth + gutterSize));
};

exports.getColumnCount = getColumnCount;

var getColumnWidth = function getColumnWidth(containerWidth, columnCount, gutterSize) {
  return (containerWidth - (columnCount - 1) * gutterSize) / columnCount;
};

exports.getColumnWidth = getColumnWidth;

var getActualColumnWidth = function getActualColumnWidth() {
  var containerWidth = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var minColumnWidth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 200;
  var gutterSize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  var columnCount = getColumnCount(containerWidth, minColumnWidth, gutterSize);
  return getColumnWidth(containerWidth, columnCount, gutterSize);
};

exports.getActualColumnWidth = getActualColumnWidth;

var getResizeImageUrl = function getResizeImageUrl() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var width = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 300;
  var cloudimageToken = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'demo';
  return "https://".concat(cloudimageToken, ".cloudimg.io/v7/").concat(processUrl(url), "w=").concat(Math.round(width));
};

exports.getResizeImageUrl = getResizeImageUrl;

var getFitResizeImageUrlWithCIcdn = function getFitResizeImageUrlWithCIcdn() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var width = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 300;
  var height = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 200;
  var cloudimageToken = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'demo';
  return "https://".concat(cloudimageToken, ".cloudimg.io/v7/").concat(processUrl(url), "func=fit&bg_color=ffffff&w=").concat(Math.round(width), "&h=").concat(Math.round(height));
};

exports.getFitResizeImageUrlWithCIcdn = getFitResizeImageUrlWithCIcdn;

var getFitResizeImageUrl = function getFitResizeImageUrl() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var width = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 300;
  var height = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 200;
  var cloudimageToken = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'demo';
  return "".concat(processUrl(url), "func=fit&bg_color=ffffff&w=").concat(Math.round(width), "&h=").concat(Math.round(height));
};

exports.getFitResizeImageUrl = getFitResizeImageUrl;

var getCropImageUrl = function getCropImageUrl() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var width = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 300;
  var height = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 200;
  var cloudimageToken = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'demo';
  return "https://".concat(cloudimageToken, ".cloudimg.io/v7/").concat(processUrl(url), "func=crop&w=").concat(Math.round(width), "&h=").concat(Math.round(height));
};

exports.getCropImageUrl = getCropImageUrl;

var processUrl = function processUrl(url) {
  return url.includes('?') ? "".concat(url, "&") : "".concat(url, "?");
};

;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(getColumnCount, "getColumnCount", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");

  __REACT_HOT_LOADER__.register(getColumnWidth, "getColumnWidth", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");

  __REACT_HOT_LOADER__.register(getActualColumnWidth, "getActualColumnWidth", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");

  __REACT_HOT_LOADER__.register(getResizeImageUrl, "getResizeImageUrl", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");

  __REACT_HOT_LOADER__.register(getFitResizeImageUrlWithCIcdn, "getFitResizeImageUrlWithCIcdn", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");

  __REACT_HOT_LOADER__.register(getFitResizeImageUrl, "getFitResizeImageUrl", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");

  __REACT_HOT_LOADER__.register(getCropImageUrl, "getCropImageUrl", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");

  __REACT_HOT_LOADER__.register(processUrl, "processUrl", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\services\\imageGrid.service.js");
}();

;