"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prepareConfig = void 0;

var _config = _interopRequireDefault(require("../config"));

var _helper = require("./helper.utils");

var _mobileDetect = _interopRequireDefault(require("mobile-detect"));

var _api = require("../services/api.service");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var prepareConfig = function prepareConfig() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var onUpload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  var container = config.container || config.CONTAINER || _config.default.container || '';
  var platform = config.platform || 'filerobot';
  var baseAPI = config.baseAPI;
  config.tagging = config.tagging || config.TAGGING || _config.default.tagging || {};
  config.modules = config.modules || [];
  config.myGallery = config.myGallery || {}; // supporting old config

  var uploadKey = config.filerobotUploadKey || config.airstoreUploadKey || config.AIRSTORE_UPLOAD_KEY;
  var md = new _mobileDetect.default(window.navigator.userAgent);
  return {
    mobile: md.mobile(),
    container: container,
    platform: platform,
    baseAPI: baseAPI,
    uploadPath: "".concat((0, _api.getBaseAPI)(baseAPI, container, platform), "upload"),
    uploadParams: config.uploadParams || config.UPLOAD_PARAMS || _config.default.uploadParams,
    uploadKey: uploadKey || _config.default.airstoreUploadKey,
    openpixKey: config.openpixKey || config.OPENPIX_KEY || _config.default.openpixKey,
    isShowAddTagBtn: (0, _helper.isDefined)(config.isShowAddTagBtn) ? config.isShowAddTagBtn : _config.default.isShowAddTagBtn,
    isShowNotRelevantBtn: (0, _helper.isDefined)(config.isShowNotRelevantBtn) ? config.isShowNotRelevantBtn : _config.default.isShowNotRelevantBtn,
    limit: config.limitImagesPerResponse || config.LIMIT_IMAGES_PER_RESPONSE || _config.default.limitImagesPerResponse || 100,
    folderBrowser: processFolderBrowserParams(config.folderBrowser, _config.default.folderBrowser),
    preUploadImageProcess: (0, _helper.isDefined)(config.preUploadImageProcess) ? config.preUploadImageProcess : false,
    processBeforeUpload: (0, _helper.isDefined)(config.processBeforeUpload) ? config.processBeforeUpload : null,
    language: (0, _helper.isDefined)(config.language) ? config.language : _config.default.language,
    cloudimageToken: config.cloudimageToken || _config.default.cloudimageToken,
    searchPhrase: config.searchPhrase,
    imageEditor: _objectSpread({
      active: config.modules.includes('IMAGE_EDITOR')
    }, config.imageEditor),
    tagging: _objectSpread(_objectSpread({
      active: config.modules.includes('TAGGING')
    }, config.tagging), {}, {
      suggestionList: config.tagging.suggestionList && config.tagging.suggestionList.length ? config.tagging.suggestionList.map(function (tag) {
        return {
          name: tag
        };
      }) : []
    }),
    autoCropSuggestions: config.autoCropSuggestions || false,
    uploadHandler: onUpload,
    imageEditorConfig: config.imageEditorConfig || {},
    myGallery: {
      upload: (0, _helper.isDefined)(config.myGallery.upload) ? config.myGallery.upload : true
    },
    sortParams: _objectSpread(_objectSpread({}, _config.default.sortParams), config.sortParams),
    extensions: config.extensions || [],
    modifyURLButton: (0, _helper.isDefined)(config.modifyURLButton) ? config.modifyURLButton : true,
    description: (0, _helper.isDefined)(config.description) ? config.description : true
  };
};

exports.prepareConfig = prepareConfig;

function processFolderBrowserParams(userParams, configParams) {
  if (_typeof(userParams) === 'object') {
    return _objectSpread(_objectSpread({}, configParams), userParams);
  } else if (typeof userParams === 'boolean') {
    return _objectSpread(_objectSpread({}, configParams), {}, {
      show: userParams
    });
  } else {
    return configParams;
  }
}

;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(prepareConfig, "prepareConfig", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\global.utils.js");

  __REACT_HOT_LOADER__.register(processFolderBrowserParams, "processFolderBrowserParams", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\global.utils.js");
}();

;