"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkIsEDGYMetadataVersion = exports.getTags = exports.encodePermalink = exports.isDefined = exports.isEsc = exports.deepCopy = exports.cursorToEnd = exports.isEnterClick = exports.uniqueArrayOfStringsInObject = exports.nonUniqueArrayOfStrings = exports.uniqueArrayOfStrings = void 0;

var _metadata = require("./metadata.constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var deepCopy = function deepCopy(object) {
  return JSON.parse(JSON.stringify(object));
};

exports.deepCopy = deepCopy;

var cursorToEnd = function cursorToEnd(contentEditableElement) {
  var range, selection;

  if (document.createRange) // Firefox, Chrome, Opera, Safari, IE 9+
    {
      range = document.createRange(); // Create a range (a range is a like the selection but invisible)

      range.selectNodeContents(contentEditableElement); // Select the entire contents of the element with the range

      range.collapse(false); // collapse the range to the end point. false means collapse to end rather than the start

      selection = window.getSelection(); // get the selection object (allows you to change selection)

      selection.removeAllRanges(); // remove any selections already made

      selection.addRange(range); // make the range you have just created the visible selection
    } else if (document.selection) // IE 8 and lower
    {
      range = document.body.createTextRange(); // Create a range (a range is a like the selection but invisible)

      range.moveToElementText(contentEditableElement); // Select the entire contents of the element with the range

      range.collapse(false); // collapse the range to the end point. false means collapse to end rather than the start

      range.select(); // Select the range (make it the visible selection
    }
};

exports.cursorToEnd = cursorToEnd;

var isEnterClick = function isEnterClick(event) {
  return event && (event.which || event.keyCode) === 13;
};

exports.isEnterClick = isEnterClick;

var isEsc = function isEsc(event) {
  return event && (event.which || event.keyCode) === 27;
};

exports.isEsc = isEsc;

var uniqueArrayOfStrings = function uniqueArrayOfStrings(array) {
  return array.filter(function (v, i, a) {
    return a.indexOf(v) === i;
  });
};

exports.uniqueArrayOfStrings = uniqueArrayOfStrings;

var getTags = function getTags(isOneFile, file, tags, personalTags) {
  return isOneFile ? tags : uniqueArrayOfStrings([].concat(_toConsumableArray(tags), _toConsumableArray(personalTags[file.uuid] || [])));
};

exports.getTags = getTags;

var uniqueArrayOfStringsInObject = function uniqueArrayOfStringsInObject(object) {
  var nextObject = {};
  Object.keys(object).forEach(function (key) {
    return nextObject[key] = object[key].filter(function (v, i, a) {
      return a.indexOf(v) === i;
    });
  });
  return nextObject;
};

exports.uniqueArrayOfStringsInObject = uniqueArrayOfStringsInObject;

var nonUniqueArrayOfStrings = function nonUniqueArrayOfStrings(tags, itemAmounts) {
  var commonTags = [];
  var duplicates = tags.reduce(function (tag, value) {
    return _objectSpread(_objectSpread({}, tag), {}, _defineProperty({}, value, (tag[value] || 0) + 1));
  }, {});
  Object.keys(duplicates).forEach(function (key) {
    if (duplicates[key] === itemAmounts) commonTags.push(key);
  });
  return commonTags;
};

exports.nonUniqueArrayOfStrings = nonUniqueArrayOfStrings;

var isDefined = function isDefined(param) {
  return typeof param !== 'undefined';
};

exports.isDefined = isDefined;

var encodePermalink = function encodePermalink(link) {
  return link;
}; // link.replace(/\?/g, '%3F');


exports.encodePermalink = encodePermalink;

var checkIsEDGYMetadataVersion = function checkIsEDGYMetadataVersion(metadataVersion) {
  return metadataVersion === (_metadata.METADATA_VERSIONS.M1_EDGY || metadataVersion === _metadata.METADATA_VERSIONS.DEPRECATED_V1_EDGY);
};

exports.checkIsEDGYMetadataVersion = checkIsEDGYMetadataVersion;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(deepCopy, "deepCopy", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(cursorToEnd, "cursorToEnd", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(isEnterClick, "isEnterClick", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(isEsc, "isEsc", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(uniqueArrayOfStrings, "uniqueArrayOfStrings", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(getTags, "getTags", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(uniqueArrayOfStringsInObject, "uniqueArrayOfStringsInObject", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(nonUniqueArrayOfStrings, "nonUniqueArrayOfStrings", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(isDefined, "isDefined", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(encodePermalink, "encodePermalink", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");

  __REACT_HOT_LOADER__.register(checkIsEDGYMetadataVersion, "checkIsEDGYMetadataVersion", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\helper.utils.js");
}();

;