"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isAllImages = exports.isImage = exports.getFileType = exports.getFileIconSrcByType = void 0;
// We can get images here: https://www.flaticon.com/packs/file-types
var fileTypeIcons = {
  _default: 'https://image.flaticon.com/icons/png/128/136/136549.png',
  png: 'https://image.flaticon.com/icons/png/128/136/136523.png',
  jpeg: 'https://image.flaticon.com/icons/png/128/136/136524.png',
  svg: 'https://image.flaticon.com/icons/png/128/136/136537.png',
  html: 'https://image.flaticon.com/icons/png/128/136/136528.png',
  photoshop: 'https://image.flaticon.com/icons/png/128/136/136535.png',
  txt: 'https://image.flaticon.com/icons/png/128/136/136538.png',
  js: 'https://image.flaticon.com/icons/png/128/136/136530.png',
  css: 'https://image.flaticon.com/icons/png/128/136/136527.png',
  xml: 'https://image.flaticon.com/icons/png/128/136/136526.png',
  zip: 'https://image.flaticon.com/icons/png/128/136/136544.png',
  json: 'https://image.flaticon.com/icons/png/128/136/136525.png',
  csv: 'https://image.flaticon.com/icons/png/128/136/136534.png',
  avi: 'https://image.flaticon.com/icons/png/128/136/136546.png',
  mp4: 'https://image.flaticon.com/icons/png/128/136/136545.png',
  mp3: 'https://image.flaticon.com/icons/png/128/136/136548.png',
  iso: 'https://image.flaticon.com/icons/png/128/136/136541.png',
  exe: 'https://image.flaticon.com/icons/png/128/136/136531.png',
  rtf: 'https://image.flaticon.com/icons/png/128/136/136539.png',
  dbf: 'https://image.flaticon.com/icons/png/128/136/136533.png',
  dwg: 'https://image.flaticon.com/icons/png/128/136/136542.png',
  fla: 'https://image.flaticon.com/icons/png/128/136/136547.png'
};

var getFileType = function getFileType(fullType) {
  var availableTypes = Object.keys(fileTypeIcons).filter(function (_type) {
    return _type !== '_default';
  });

  var checkType = function checkType(_type) {
    if (fullType === 'text/plain' && _type === 'txt') return true;
    return new RegExp(_type).test(fullType);
  };

  return fullType ? availableTypes.find(function (_type) {
    return checkType(_type);
  }) : null;
};

exports.getFileType = getFileType;

var getFileIconSrcByType = function getFileIconSrcByType(type) {
  var fileType = getFileType(type);
  return fileTypeIcons[fileType] || fileTypeIcons._default;
};

exports.getFileIconSrcByType = getFileIconSrcByType;

var isImage = function isImage(type) {
  return type.indexOf('image') > -1;
};

exports.isImage = isImage;

var isAllImages = function isAllImages(files) {
  return files.every(function (file) {
    return file.type.indexOf('image') > -1;
  });
};

exports.isAllImages = isAllImages;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(fileTypeIcons, "fileTypeIcons", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\icons.utils.js");

  __REACT_HOT_LOADER__.register(getFileType, "getFileType", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\icons.utils.js");

  __REACT_HOT_LOADER__.register(getFileIconSrcByType, "getFileIconSrcByType", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\icons.utils.js");

  __REACT_HOT_LOADER__.register(isImage, "isImage", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\icons.utils.js");

  __REACT_HOT_LOADER__.register(isAllImages, "isAllImages", "D:\\Work\\Projects\\filerobot-uploader\\projects\\react-plugin\\utils\\icons.utils.js");
}();

;